@echo off
setlocal

set ISAS_BIN=%IS_HOME%\bin
set PRMDIR="..\parampkg"
set EMPTY=__EMPTY__
set ERROR_MSG=
set errflg=0

REM  Set environment variable
call ./setenv.cmd


REM Apache definition update
call %ISAS_BIN%\isihsconfigset
if ERRORLEVEL 1 (
    set ERROR_MSG=%ERROR_MSG%[isihsconfigset]
    set errflg=1
)

REM isj2eeadmin check
if EXIST "%IS_HOME%\bin\isj2eeadmin.exe" (

    REM JMX start
    net start "Interstage Operation Tool"

    REM OD start
    net start "OD_start"

    REM IJServer definition update
    if defined J2ee_IjserverDefinition if not "%J2ee_IjserverDefinition%"=="%EMPTY%" (
        %ISAS_BIN%\isj2eeadmin.exe ijserver -o -f "%PRMDIR%\%J2ee_IjserverDefinition%"
        if ERRORLEVEL 1 (
            set ERROR_MSG=%ERROR_MSG%[IjserverDefinition]
            set errflg=1
        )
    )

    REM J2EE System definition update
    if defined J2ee_SystemDefinition if not "%J2ee_SystemDefinition%"=="%EMPTY%" (
        %ISAS_BIN%\isj2eeadmin.exe system   -o -f "%PRMDIR%\%J2ee_SystemDefinition%"
        if ERRORLEVEL 1 (
            set ERROR_MSG=%ERROR_MSG%[SystemDefinition]
            set errflg=1
        )
    )

    REM J2EE Resource definition update
    if defined J2ee_ResourceDefinition if not "%J2ee_ResourceDefinition%"=="%EMPTY%" (
        %ISAS_BIN%\isj2eeadmin.exe resource -o -f "%PRMDIR%\%J2ee_ResourceDefinition%"
        if ERRORLEVEL 1 (
            set ERROR_MSG=%ERROR_MSG%[ResourceDefinition]
            set errflg=1
        )
    )

    REM Sever Connector definition update
    if defined J2ee_ServiceDefinition if not "%J2ee_ServiceDefinition%"=="%EMPTY%" (
        %ISAS_BIN%\isj2eeadmin.exe service  -o -f  "%PRMDIR%\%J2ee_ServiceDefinition%"
        if ERRORLEVEL 1 (
            set ERROR_MSG=%ERROR_MSG%[ServiceDefinition]
            set errflg=1
        )
    )

    REM OD stop
    net stop "OD_start" /Y

    REM JMX stop
    net stop "Interstage Operation Tool"
)


REM ISAS Cloning
call %ISAS_BIN%\issethostinfo -h %hostname% -i %ipaddress% &
if ERRORLEVEL 1 (
    set ERROR_MSG=%ERROR_MSG%[issethostinfo]
    set errflg=1
)

REM ISI Cloning
%JAVA_HOME%\bin\java -jar %~dp0\ISISetHostProperties.jar %hostname%
if ERRORLEVEL 1 (
    set ERROR_MSG=%ERROR_MSG%[ISISetHostProperties]
    set errflg=1
)


REM error
if %errflg% NEQ 0 (
    echo [ISI]Error has occurred :%ERROR_MSG%
    exit /B 1
    endlocal 
)

REM normal
    echo [ISI]Setup has been finished normally
    exit /B 0
    endlocal

