@ECHO OFF
SETLOCAL

CALL ./setenv.cmd

SET ANALYTICS_J2EE_CONF_DIR=%IS_J2EEAPF%\ijserver\IBPMMServer\apps\ibpmm.war\conf

IF NOT EXIST %ANALYTICS_J2EE_CONF_DIR% (
	ECHO BCMD2001:BPM Analytics Server is not installed.
	GOTO END_ERROR
)

@REM localconfig.properties

SET LOCAL_CONFIG_PROP=%ANALYTICS_J2EE_CONF_DIR%\localconfig.properties
SET TMP_LOCAL_CONFIG_PROP=.\localconfig.properties

IF NOT EXIST %LOCAL_CONFIG_PROP% (
	ECHO BCMD2002:Necessary configuration file[localconfig.properties] is missing.
	GOTO END_ERROR
)

ECHO # Properties of local configuration for Analytics system> %TMP_LOCAL_CONFIG_PROP%
ECHO # This file must be edited by Analytics installer.>> %TMP_LOCAL_CONFIG_PROP%
ECHO #>> %TMP_LOCAL_CONFIG_PROP%
ECHO # ALL RIGHTS RESERVED, COPYRIGHT (c) FUJITSU LIMITED 2009>> %TMP_LOCAL_CONFIG_PROP%
ECHO.>> %TMP_LOCAL_CONFIG_PROP%
ECHO framework.host=%bpmanalytics_hostname%>> %TMP_LOCAL_CONFIG_PROP%
ECHO framework.port=%bpmanalytics_portno%>> %TMP_LOCAL_CONFIG_PROP%

@REM RepClientConfig.properties

SET REP_CLIENT_CONFIG_PROP=%ANALYTICS_J2EE_CONF_DIR%\RepClientConfig.properties
SET TMP_REP_CLIENT_CONFIG_PROP=.\RepClientConfig.properties
SET REP_ROOT_PATH=

IF NOT EXIST %REP_CLIENT_CONFIG_PROP% (
	ECHO BCMD2002:Necessary configuration file[RepClientConfig.properties] is missing.
	GOTO END_ERROR
)

FOR /F "delims=," %%a IN ('findstr /B "RepRootPath" %REP_CLIENT_CONFIG_PROP%') DO (
	SET REP_ROOT_PATH=%%a
)

ECHO #Repository Client API - Connection Information> %TMP_REP_CLIENT_CONFIG_PROP%
ECHO isLocal=true>> %TMP_REP_CLIENT_CONFIG_PROP%
ECHO %REP_ROOT_PATH%>> %TMP_REP_CLIENT_CONFIG_PROP%
ECHO RepHostname=localhost:%bpmanalytics_portno%>> %TMP_REP_CLIENT_CONFIG_PROP%
ECHO.>> %TMP_REP_CLIENT_CONFIG_PROP%
ECHO isEnableSSL=false>> %TMP_REP_CLIENT_CONFIG_PROP%
ECHO.>> %TMP_REP_CLIENT_CONFIG_PROP%
ECHO BPM_REP_MAXAUTHCOUNT=100>> %TMP_REP_CLIENT_CONFIG_PROP%
ECHO BPM_REP_AUTHINTERVAL=3000>> %TMP_REP_CLIENT_CONFIG_PROP%

@REM ActivityMonitor_init.properties

SET ACT_MON_INIT_PROP=%ANALYTICS_J2EE_CONF_DIR%\ActivityMonitor_init.properties
SET TMP_ACT_MON_INIT_PROP=.\ActivityMonitor_init.properties

IF NOT EXIST %ACT_MON_INIT_PROP% (
	ECHO BCMD2002:Necessary configuration file[ActivityMonitor_init.properties] is missing.
	GOTO END_ERROR
)

ECHO server.schema=http> %TMP_ACT_MON_INIT_PROP%
ECHO server.host=%bpmanalytics_hostname%>> %TMP_ACT_MON_INIT_PROP%
ECHO server.port=%bpmanalytics_portno%>> %TMP_ACT_MON_INIT_PROP%
ECHO dashboard.servlet.delete.interval=10>> %TMP_ACT_MON_INIT_PROP%
ECHO dashboard.servlet.delete.ttl=7200>> %TMP_ACT_MON_INIT_PROP%
ECHO display.alert.max.index=1 >> %TMP_ACT_MON_INIT_PROP%
ECHO display.alert.max.list=10,50,100,300,500>> %TMP_ACT_MON_INIT_PROP%
ECHO display.process.max.index=1 >> %TMP_ACT_MON_INIT_PROP%
ECHO display.process.max.list=10,50,100,300,500>> %TMP_ACT_MON_INIT_PROP%
ECHO display.comment.max.index=1 >> %TMP_ACT_MON_INIT_PROP%
ECHO display.comment.max.list=10,50,100,300,500>> %TMP_ACT_MON_INIT_PROP%
ECHO # if false, not displayed at the Tracking View.>> %TMP_ACT_MON_INIT_PROP%
ECHO # Process Owner>> %TMP_ACT_MON_INIT_PROP%
ECHO workflow.process.owner.isDisplayed=true>> %TMP_ACT_MON_INIT_PROP%
ECHO # Process Assignee>> %TMP_ACT_MON_INIT_PROP%
ECHO workflow.process.assignee.isDisplayed=true>> %TMP_ACT_MON_INIT_PROP%
ECHO # Process Instantiator>> %TMP_ACT_MON_INIT_PROP%
ECHO workflow.process.instantiator.isDisplayed=true>> %TMP_ACT_MON_INIT_PROP%
ECHO # Process Instance Id>> %TMP_ACT_MON_INIT_PROP%
ECHO workflow.process.instanceId.isDisplayed=true>> %TMP_ACT_MON_INIT_PROP%
ECHO # Process Version>> %TMP_ACT_MON_INIT_PROP%
ECHO workflow.process.version.isDisplayed=true>> %TMP_ACT_MON_INIT_PROP%
ECHO # If you change default size of font on chart label, edit number. (6-72)>> %TMP_ACT_MON_INIT_PROP%
ECHO dashboard.chart.label.fontsize=>> %TMP_ACT_MON_INIT_PROP%
ECHO # Guard editing screen on chart view>> %TMP_ACT_MON_INIT_PROP%
ECHO dashboard.chart.edit.guard=false>> %TMP_ACT_MON_INIT_PROP%

@REM agentsdk-conf.xml

SET AGENT_SDK_CONF=%ANALYTICS_J2EE_CONF_DIR%\agentsdk-conf.xml
SET TMP_AGENT_SDK_CONF=.\agentsdk-conf.xml

IF NOT EXIST %AGENT_SDK_CONF% (
	ECHO BCMD2002:Necessary configuration file[agentsdk-conf.xml] is missing.
	GOTO END_ERROR
)

SET REP_ROOT=%REP_ROOT_PATH:~12,13%

ECHO ^<?xml version="1.0"?^>> %TMP_AGENT_SDK_CONF%
ECHO ^<!DOCTYPE agentsdk-conf SYSTEM "file://agentsdk-conf.dtd"^>>> %TMP_AGENT_SDK_CONF%
ECHO ^<agentsdk-conf^>>> %TMP_AGENT_SDK_CONF%
ECHO   ^<conf^>>> %TMP_AGENT_SDK_CONF%
ECHO     ^<system locale="ja"^>>> %TMP_AGENT_SDK_CONF%
ECHO       ^<framework taskWaitTime="5" /^>>> %TMP_AGENT_SDK_CONF%
ECHO     ^</system^>>> %TMP_AGENT_SDK_CONF%
ECHO     ^<event containerPath="%REP_ROOT%/event/sensor">> %TMP_AGENT_SDK_CONF%
ECHO            maxbufferedevents="100000" /^>>> %TMP_AGENT_SDK_CONF%
ECHO     ^<extendedcommand protocol="HTTP" /^>>> %TMP_AGENT_SDK_CONF%
ECHO     ^<agentworking path="agent/work" /^>>> %TMP_AGENT_SDK_CONF%
ECHO   ^</conf^>>> %TMP_AGENT_SDK_CONF%
ECHO   ^<registration^>>> %TMP_AGENT_SDK_CONF%
ECHO     ^<server id="" /^>>> %TMP_AGENT_SDK_CONF%
ECHO     ^<application name="%bpmanalytics_hostname%">> %TMP_AGENT_SDK_CONF%
ECHO                  maxwefevents="3000">> %TMP_AGENT_SDK_CONF%
ECHO                  host="http://%bpmanalytics_hostname%:%bpmanalytics_portno%">> %TMP_AGENT_SDK_CONF%
ECHO                  path="/ibpmm/BPMASExtendedCommand" /^>>> %TMP_AGENT_SDK_CONF%
ECHO     ^<encrypt passphrase="axfa4qyvQaQMI0/NR298zQ==" /^>>> %TMP_AGENT_SDK_CONF%
ECHO   ^</registration^>>> %TMP_AGENT_SDK_CONF%
ECHO ^</agentsdk-conf^>>> %TMP_AGENT_SDK_CONF%

COPY /Y %TMP_LOCAL_CONFIG_PROP% %LOCAL_CONFIG_PROP%
COPY /Y %TMP_REP_CLIENT_CONFIG_PROP% %REP_CLIENT_CONFIG_PROP%
COPY /Y %TMP_ACT_MON_INIT_PROP% %ACT_MON_INIT_PROP%
COPY /Y %TMP_AGENT_SDK_CONF% %AGENT_SDK_CONF%

DEL %TMP_LOCAL_CONFIG_PROP%
DEL %TMP_REP_CLIENT_CONFIG_PROP%
DEL %TMP_ACT_MON_INIT_PROP%
DEL %TMP_AGENT_SDK_CONF%

IF ERRORLEVEL 1 (
	ECHO BCMD2003:Unknown error has occurred.
	GOTO END_ERROR
)

ENDLOCAL
EXIT /B 0

:END_ERROR
ENDLOCAL
EXIT /B 1
