#!/bin/sh

ECHO=/bin/echo
GREP=/bin/grep
COPY=/bin/cp
REM=/bin/rm

source ./setenv.sh

HOSTNAME=$bpmanalytics_hostname
PORTNO=$bpmanalytics_portno

ANALYTICS_J2EE_CONF_DIR=/var/opt/FJSVj2ee/deployment/ijserver/IBPMMServer/apps/ibpmm.war/conf

if [ ! -d $ANALYTICS_J2EE_CONF_DIR ]; then
	$ECHO "BCMD2001:BPM Analytics Server is not installed."
	exit 1
fi


#====================================================================================
# Configure localconfig.properties
#====================================================================================

LOCAL_CONFIG_PROP=$ANALYTICS_J2EE_CONF_DIR/localconfig.properties
TMP_LOCAL_CONFIG_PROP=./localconfig.properties

if [ ! -e $LOCAL_CONFIG_PROP ]; then
	$ECHO "BCMD2002:Necessary configuration file[localconfig.properties] is missing."
	exit 1
fi

$ECHO "# Properties of local configuration for Analytics system"> $TMP_LOCAL_CONFIG_PROP
$ECHO "# This file must be edited by Analytics installer.">> $TMP_LOCAL_CONFIG_PROP
$ECHO "# ">> $TMP_LOCAL_CONFIG_PROP
$ECHO "# ALL RIGHTS RESERVED, COPYRIGHT (c) FUJITSU LIMITED 2009">> $TMP_LOCAL_CONFIG_PROP
$ECHO "">> $TMP_LOCAL_CONFIG_PROP
$ECHO "framework.host=$HOSTNAME">> $TMP_LOCAL_CONFIG_PROP
$ECHO "framework.port=$PORTNO">> $TMP_LOCAL_CONFIG_PROP
$ECHO "">> $TMP_LOCAL_CONFIG_PROP

#====================================================================================
# Configure RepClientConfig.properties
#====================================================================================

REP_CLIENT_CONFIG_PROP=$ANALYTICS_J2EE_CONF_DIR/RepClientConfig.properties
TMP_REP_CLIENT_CONFIG_PROP=./RepClientConfig.properties
REP_ROOT_PATH=

if [ ! -e $REP_CLIENT_CONFIG_PROP ]; then
	$ECHO "BCMD2002:Necessary configuration file[RepClientConfig.properties] is missing."
	exit 1
fi

TMP_REP_ROOT_PATH="$GREP RepRootPath $REP_CLIENT_CONFIG_PROP"
TMP_REP_ROOT_PATH2=("echo `$TMP_REP_ROOT_PATH`")
REP_ROOT_PATH=(`$TMP_REP_ROOT_PATH2`)

$ECHO "#Repository Client API - Connection Information"> $TMP_REP_CLIENT_CONFIG_PROP
$ECHO "isLocal=true">> $TMP_REP_CLIENT_CONFIG_PROP
$ECHO "$REP_ROOT_PATH">> $TMP_REP_CLIENT_CONFIG_PROP
$ECHO "RepHostname=localhost:$PORTNO">> $TMP_REP_CLIENT_CONFIG_PROP
$ECHO "">> $TMP_REP_CLIENT_CONFIG_PROP
$ECHO "isEnableSSL=false">> $TMP_REP_CLIENT_CONFIG_PROP
$ECHO "">> $TMP_REP_CLIENT_CONFIG_PROP
$ECHO "BPM_REP_MAXAUTHCOUNT=100">> $TMP_REP_CLIENT_CONFIG_PROP
$ECHO "BPM_REP_AUTHINTERVAL=3000">> $TMP_REP_CLIENT_CONFIG_PROP

#====================================================================================
# Configure ActivityMonitor_init.properties
#====================================================================================

ACT_MON_INIT_PROP=$ANALYTICS_J2EE_CONF_DIR/ActivityMonitor_init.properties
TMP_ACT_MON_INIT_PROP=./ActivityMonitor_init.properties

if [ ! -e $ACT_MON_INIT_PROP ]; then
	$ECHO "BCMD2002:Necessary configuration file[ActivityMonitor_init.properties] is missing."
	exit 1
fi

$ECHO "server.schema=http"> $TMP_ACT_MON_INIT_PROP
$ECHO "server.host=$HOSTNAME">> $TMP_ACT_MON_INIT_PROP
$ECHO "server.port=$PORTNO">> $TMP_ACT_MON_INIT_PROP
$ECHO "dashboard.servlet.delete.interval=10">> $TMP_ACT_MON_INIT_PROP
$ECHO "dashboard.servlet.delete.ttl=7200">> $TMP_ACT_MON_INIT_PROP
$ECHO "">> $TMP_ACT_MON_INIT_PROP
$ECHO "display.alert.max.index=1">> $TMP_ACT_MON_INIT_PROP
$ECHO "display.alert.max.list=10,50,100,300,500">> $TMP_ACT_MON_INIT_PROP
$ECHO "display.process.max.index=1">> $TMP_ACT_MON_INIT_PROP
$ECHO "display.process.max.list=10,50,100,300,500">> $TMP_ACT_MON_INIT_PROP
$ECHO "display.comment.max.index=1">> $TMP_ACT_MON_INIT_PROP
$ECHO "display.comment.max.list=10,50,100,300,500">> $TMP_ACT_MON_INIT_PROP
$ECHO "">> $TMP_ACT_MON_INIT_PROP
$ECHO "# if false, not displayed at the Tracking View.">> $TMP_ACT_MON_INIT_PROP
$ECHO "# Process Owner">> $TMP_ACT_MON_INIT_PROP
$ECHO "workflow.process.owner.isDisplayed=true">> $TMP_ACT_MON_INIT_PROP
$ECHO "# Process Assignee">> $TMP_ACT_MON_INIT_PROP
$ECHO "workflow.process.assignee.isDisplayed=true">> $TMP_ACT_MON_INIT_PROP
$ECHO "# Process Instantiator">> $TMP_ACT_MON_INIT_PROP
$ECHO "workflow.process.instantiator.isDisplayed=true">> $TMP_ACT_MON_INIT_PROP
$ECHO "# Process Instance Id">> $TMP_ACT_MON_INIT_PROP
$ECHO "workflow.process.instanceId.isDisplayed=true">> $TMP_ACT_MON_INIT_PROP
$ECHO "# Process Version">> $TMP_ACT_MON_INIT_PROP
$ECHO "workflow.process.version.isDisplayed=true">> $TMP_ACT_MON_INIT_PROP
$ECHO "">> $TMP_ACT_MON_INIT_PROP
$ECHO "# If you change default size of font on chart label, edit number. (6-72)">> $TMP_ACT_MON_INIT_PROP
$ECHO "dashboard.chart.label.fontsize=">> $TMP_ACT_MON_INIT_PROP
$ECHO "">> $TMP_ACT_MON_INIT_PROP
$ECHO "# Guard editing screen on chart view">> $TMP_ACT_MON_INIT_PROP
$ECHO "dashboard.chart.edit.guard=false">> $TMP_ACT_MON_INIT_PROP
$ECHO "">> $TMP_ACT_MON_INIT_PROP

#====================================================================================
# Configure agentsdk-conf.xml
#====================================================================================

AGENT_SDK_CONF=$ANALYTICS_J2EE_CONF_DIR/agentsdk-conf.xml
TMP_AGENT_SDK_CONF=./agentsdk-conf.xml

if [ ! -e $AGENT_SDK_CONF ]; then
	$ECHO "BCMD2002:Necessary configuration file[agentsdk-conf.xml] is missing."
	exit 1
fi

case $LANG in
ja*) IBPMA_LANG=ja;;
*)   IBPMA_LANG=en;;
esac

$ECHO "<?xml version=\"1.0\"?>"> $TMP_AGENT_SDK_CONF
$ECHO "<!DOCTYPE agentsdk-conf SYSTEM \"file://agentsdk-conf.dtd\">">> $TMP_AGENT_SDK_CONF
$ECHO "<agentsdk-conf>">> $TMP_AGENT_SDK_CONF
$ECHO "  <conf>">> $TMP_AGENT_SDK_CONF
$ECHO "    <system locale=\"$IBPMA_LANG\">">> $TMP_AGENT_SDK_CONF
$ECHO "      <framework taskWaitTime=\"5\" />">> $TMP_AGENT_SDK_CONF
$ECHO "    </system>">> $TMP_AGENT_SDK_CONF
$ECHO "    <event containerPath=\"/var/opt/FJSVibpma/event/sensor\"">> $TMP_AGENT_SDK_CONF
$ECHO "           maxbufferedevents=\"100000\" />">> $TMP_AGENT_SDK_CONF
$ECHO "    <extendedcommand protocol=\"HTTP\" />">> $TMP_AGENT_SDK_CONF
$ECHO "    <agentworking path=\"agent/work\" />">> $TMP_AGENT_SDK_CONF
$ECHO "  </conf>">> $TMP_AGENT_SDK_CONF
$ECHO "  <registration>">> $TMP_AGENT_SDK_CONF
$ECHO "    <server id=\"\" />">> $TMP_AGENT_SDK_CONF
$ECHO "    <application name=\"$HOSTNAME\"">> $TMP_AGENT_SDK_CONF
$ECHO "                 maxwefevents=\"3000\"">> $TMP_AGENT_SDK_CONF
$ECHO "                 host=\"http://$HOSTNAME:$PORTNO\"">> $TMP_AGENT_SDK_CONF
$ECHO "                 path=\"/ibpmm/BPMASExtendedCommand\" />">> $TMP_AGENT_SDK_CONF
$ECHO "    <encrypt passphrase=\"axfa4qyvQaQMI0/NR298zQ==\" />">> $TMP_AGENT_SDK_CONF
$ECHO "  </registration>">> $TMP_AGENT_SDK_CONF
$ECHO "</agentsdk-conf>">> $TMP_AGENT_SDK_CONF

#====================================================================================
# Copy new configuration files to Analytics Server
#====================================================================================

$COPY $TMP_LOCAL_CONFIG_PROP $LOCAL_CONFIG_PROP
$COPY $TMP_REP_CLIENT_CONFIG_PROP $REP_CLIENT_CONFIG_PROP
$COPY $TMP_ACT_MON_INIT_PROP $ACT_MON_INIT_PROP
$COPY $TMP_AGENT_SDK_CONF $AGENT_SDK_CONF

$REM $TMP_LOCAL_CONFIG_PROP
$REM $TMP_REP_CLIENT_CONFIG_PROP
$REM $TMP_ACT_MON_INIT_PROP
$REM $TMP_AGENT_SDK_CONF

if [ $? -ne 0 ]; then
	$ECHO "BCMD2003:Unknown error has occurred."
	exit 1
else
	exit 0
fi
