'PRODUCT_VERSION=3.0.21.1
'SPECIAL_VERSION=InterStage-Patch-20050621
'
' PrepService.vbs
'
' T[rXN}~Ec[
'
' Copyright (C) FUJITSU LIMITED 2004-2005
'
Option Explicit


'G[R[h`
Const ERROR_SV_SUCCESS			= 0
Const ERROR_SV_UNKNOWN			= 101
Const ERROR_SV_BADCOMMAND		= 102
Const ERROR_SV_BADENVIRONMENT	= 103
Const ERROR_SV_BADOPTION		= 104
Const ERROR_SV_TARGETCONFLICT	= 105
Const ERROR_SV_NOTARGET			= 106
Const ERROR_SV_NOGROUP			= 107
Const ERROR_SV_READNAMEFILE		= 108
Const ERROR_SV_READREGFILE		= 109
Const ERROR_SV_WRITEREGFILE		= 110
Const ERROR_SV_BADREGFILE		= 111
Const ERROR_SV_GROUPNOTFOUND	= 112
Const ERROR_SV_READSTATEFILE	= 113
Const ERROR_SV_WRITESTATEFILE	= 114
Const ERROR_SV_BADSTATEFILE		= 115
Const ERROR_SV_SUPPRESSSTARTUP	= 116
Const ERROR_SV_STOPSERVICE		= 117
Const ERROR_SV_NOSTATEFILE		= 118
Const ERROR_SV_RESTORESTARTUP	= 119
Const ERROR_SV_STARTSERVICE		= 120



Const strEnvLogFile		= "SCW_PREP_SERVICE_LOG"
Const strRegistFile		= "svcinfo.xml"
Const strDefStateFile	= "svcstate.txt"

' ]T[rX~߂AeT[rX~߂܂ł̎Ԃ̃ftHg
Const lngDefWait = 10

' gC񐔂̃ftHg
Const lngDefMaxRetry = 600


' G[
Sub RaiseError(num, desc)
	Dim strMsg
	strMsg = "ERROR(" & CStr(num) & "): " & desc
	Call Trace(strMsg)
	WScript.Echo(strMsg)
	Err.Raise vbObjectError + num, , desc
End Sub

' Win32_ServicẽG[bZ[W擾(Op)
Function GetServiceErrorMessage(ByVal lngError)
	Dim strRet
	Select Case lngError
		Case 0		strRet = "Success"
		Case 1		strRet = "Not Supported"
		Case 2		strRet = "Access Denied"
		Case 3		strRet = "Dependent Services Running"
		Case 4		strRet = "Invalid Service Control"
		Case 5		strRet = "Service Cannot Accept Control"
		Case 6		strRet = "Service Not Active"
		Case 7		strRet = "Service Request Timeout"
		Case 8		strRet = "Unknown Failure"
		Case 9		strRet = "Path Not Found"
		Case 10		strRet = "Service Already Running/Stopped"
		Case 11		strRet = "Service Database Locked"
		Case 12		strRet = "Service Dependency Deleted"
		Case 13		strRet = "Service Dependency Failure"
		Case 14		strRet = "Service Disabled"
		Case 15		strRet = "Service Logon Failure"
		Case 16		strRet = "Service Marked For Deletion"
		Case 17		strRet = "Service No Thread"
		Case 18		strRet = "Status Circular Dependency"
		Case 19		strRet = "Status Duplicate Name"
		Case 20		strRet = "Status Invalid Name"
		Case 21		strRet = "Status Invalid Parameter"
		Case 22		strRet = "Status Invalid Service Account"
		Case 23		strRet = "Status Service Exists"
		Case 24		strRet = "Service Already Paused"
		Case Else	strRet = "Unknown Error Code"
	End Select
	GetServiceErrorMessage = strRet
End Function

' gp@\
Sub Usage
	Dim strMsg
	strMsg = "Usage:" & vbCrLf &_
		"cscript.exe //nologo prepservice.vbs <subcommand> [options...]" & vbCrLf & vbCrLf &_
		"Subcommands:" & vbCrLf & vbCrLf &_
		"  Register { -N:Service | -F:ListFile } -G:Group [ -C:Category ]" & vbCrLf &_
		"    Registers specified services as targets and associate the group." & vbCrLf & vbCrLf &_
		"  Unregister -G:Group" & vbCrLf &_
		"    Removes all services associated with specified group from targets." & vbCrLf & vbCrLf &_
		"  SuppressStartup [ -O:File ] [ -R:Count ] [ -C:Category ]" & vbCrLf &_
		"    Preserves startup mode and running state of the registered services" & vbCrLf &_
		"    to the file. Afterwards, switch startup mode to ""Manual""." & vbCrLf & vbCrLf &_
		"  StopServices [ -W:Wait ] [ -R:Count ] [ -C:Category ]" & vbCrLf &_
		"    Stops the registered services." & vbCrLf & vbCrLf &_
		"  SaveAndStop [ -O:File ] [ -W:Wait ] [ -R:Count ] [ -C:Category ]" & vbCrLf &_
		"    Executes both ""SuppressStartup"" and ""StopServices"" at a time." & vbCrLf & vbCrLf &_
		"  RestoreStartup [ -O:File ] [ -R:Count ] [ -C:Category ]" & vbCrLf &_
		"    Restores startup mode of the registered services." & vbCrLf & vbCrLf &_
		"  StartServices [ -O:File ] [ -R:Count ] [ -C:Category ]" & vbCrLf &_
		"    Restores running state of the registered services." & vbCrLf & vbCrLf &_
		"  RestoreAndStart [ -O:SaveFile ] [ -R:RetryCount ] [ -C:Category ]" & vbCrLf &_
		"    Executes both ""RestoreStartup"" and ""StartServices"" at a time." & vbCrLf & vbCrLf &_
		"  ListServices" & vbCrLf &_
		"    Lists all services to STDOUT. (for convenience making a service list" & vbCrLf &_
		"    file)" & vbCrLf
	WScript.Echo(strMsg)
End Sub


' Oo
Sub Trace(strLog)
	Dim objFSO, objShell, objEnv, objLogFile, strLogFile
	Set objShell = WScript.CreateObject("WScript.Shell")
	Set objEnv = objShell.Environment("Process")
	strLogFile = objEnv(strEnvLogFile)

'	WScript.Echo(strLog)
	If Len(strLogFile) > 0 Then
		Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
		Set objLogFile = objFSO.OpenTextFile(strLogFile, 8, True)
		objLogFile.WriteLine(Now & " " & strLog)
		objLogFile.Close
	End If
End Sub


' T[rX\񋓂t@Cǂ݁AarrSvcNamesɑ
Sub ReadServiceNameFile(strSvcNameFile, arrSvcNames)
	Call Trace("ReadServiceNameFile")
	
	Dim I, strLine
	Dim objFSO, objSvcNameFile
	Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
	Call Trace("Reading ServiceNameFile: " & strSvcNameFile)
	Set objSvcNameFile = objFSO.OpenTextFile(strSvcNameFile, 1)

	ReDim arrSvcNames(-1)
	I = 0
	Do Until objSvcNameFile.AtEndOfStream
		' Ő󔒂͍폜(s͖)
		strLine = Trim(objSvcNameFile.ReadLine)
		If Len(strLine) > 0 Then
			ReDim Preserve arrSvcNames(I)
			arrSvcNames(I) = strLine
			I = I + 1
		End If
	Loop
	Call Trace("Reading completed (" & CStr(I) & " items)")
End Sub


' XMLɎgpłȂGXP[v
Function EscapeString(ByVal strText)
	strText = Replace(strText, "&", "&amp;")
	strText = Replace(strText, """", "&quot;")
	strText = Replace(strText, "'", "&apos;")
	strText = Replace(strText, "<", "&lt;")
	strText = Replace(strText, ">", "&gt;")
	EscapeString = strText
End Function


' GXP[vɖ߂
Function UnescapeString(ByVal strText)
	strText = Replace(strText, "&gt;", ">")
	strText = Replace(strText, "&lt;", "<")
	strText = Replace(strText, "&apos;", "'")
	strText = Replace(strText, "&quot;", """")
	strText = Replace(strText, "&amp;", "&")
	UnescapeString = strText
End Function


' XMLt@Cɕۑ
Function SaveXML(objXML, strXMLFile)
	Dim lngTmpCode, strTmpDesc
	On Error Resume Next
	Err.Clear
	Call objXML.save(strXMLFile)
	If Err = 0 Then
		SaveXML = ""
	Else
		SaveXML = Err.Description & "(SubCode=" & CStr(Err.Number) & ")"
	End If
End Function


' o^ꂽT[rXt@Cɕۑ
' arrSvcNamesNullȂO[v폜
Sub SaveRegisteredServices(strGroup, arrSvcNames, strCategory)
	Call Trace("SaveRegisteredServices")
	Dim strRegistFilePath, strScript, nLastBS, bRet
	Dim objXML, objFSO
	Dim objRoot, objGroup, objService
	
	' o^t@C̓XNvgƓfBNgɒu
	strScript = WScript.ScriptFullName
	nLastBS = InStrRev(strScript, "\")
	strRegistFilePath = Left(strScript, nLastBS) & strRegistFile

	Set objXML = WScript.CreateObject("MSXML.DOMDocument")
	objXML.async = False
	
	' [gm[h擾
	Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
	If objFSO.FileExists(strRegistFilePath) Then
		' o^t@CłɂΓǂݍ
		Call Trace("Loading registration file: " & strRegistFilePath)
		bRet = objXML.load(strRegistFilePath)
		If Not bRet Then
			' ǂݏos
			Call RaiseError(ERROR_SV_READREGFILE, "Failed to load registered services (bad format)")
		End If
		Set objRoot = objXML.documentElement
		Call Trace("Loading completed")
	Else
		' o^t@CȂ΃[gm[h쐬
		Call Trace("No services are registered, creating registration file")
		Set objRoot = objXML.createElement("Groups")
		Set objXML.documentElement = objRoot
	End If

	' ΏۃO[v
	Set objGroup = objRoot.selectSingleNode("./Group[@Name=""" & EscapeString(strGroup) & """]")
	If IsNull(arrSvcNames) Then
		' O[v폜
		If objGroup Is Nothing Then
			Call RaiseError(ERROR_SV_GROUPNOTFOUND, "Group """ & strGroup & """ is not found")
		End If
		
		Call objRoot.removeChild(objGroup)
		Call Trace("Group """ & strGroup & """ was removed")
	Else
		' O[vɃT[rXǉ
		If objGroup Is Nothing Then
			' O[vȂ΍쐬
			Set objGroup = objXML.createElement("Group")
			Call objGroup.setAttribute("Name", EscapeString(strGroup))
			Call objRoot.appendChild(objGroup)
			Call Trace("Group """ & strGroup & """ was created")
		End If

		Dim strSvcName
		For Each strSvcName In arrSvcNames
			' T[rXāAȂΒǉ
			Set objService = objGroup.selectSingleNode("./Service[@Name=""" &_
				EscapeString(strSvcName) & """]")
			If objService Is Nothing Then
				Set objService = objXML.createElement("Service")
				Call objService.setAttribute("Name", EscapeString(strSvcName))
				If Len(strCategory) > 0 Then
					Call objService.setAttribute("Category", EscapeString(strCategory))
				End If
				Call objGroup.appendChild(objService)
				Call Trace("Added """ & strSvcName & """")
			Else
				Call Trace("Skipped """ & strSvcName & """")
			End If
		Next
	End If

	' t@CXV	
	Dim strSave
	Call Trace("Saving registration file")
	strSave = SaveXML(objXML, strRegistFilePath)
	If strSave <> "" Then
		Call RaiseError(ERROR_SV_WRITESTATEFILE, "Failed to save state file: " & strSave)
	End If
	Call Trace("Saving completed")
End Sub


' o^ꂽT[rXt@Cǂݍ݁Azɓ
Sub LoadRegisteredServices(arrSvcNames, strCategory)
	Call Trace("LoadRegisteredServices")
	Dim strRegistFilePath, strScript, nLastBS, bRet
	Dim strPattern
	Dim objXML, objFSO
	Dim objRoot, objSvcList, objService
	Dim I, strSvcName, strTmp, bFound
	
	Redim arrSvcNames(-1)	' S폜

	' o^t@C̓XNvgƓfBNgɂ
	strScript = WScript.ScriptFullName
	nLastBS = InStrRev(strScript, "\")
	strRegistFilePath = Left(strScript, nLastBS) & strRegistFile

	Set objXML = WScript.CreateObject("MSXML.DOMDocument")
	objXML.async = False

	Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
	If Not objFSO.FileExists(strRegistFilePath) Then
		' o^t@CȂ̂ŃT[rXo^
		' ΏۃAvȂƂAG[ł͂Ȃ
		Call Trace("Registration file does not exists, skipped")
		Exit Sub
	Else
		' [gm[h擾
		Call Trace("Loading registration file: " & strRegistFilePath)
		bRet = objXML.load(strRegistFilePath)
		If Not bRet Then
			Call RaiseError(ERROR_SV_READREGFILE, "Failed to load registered services (bad format)")
		End If
		Set objRoot = objXML.documentElement
		Call Trace("Loading completed")
	End If

	' O[vɂ炸T[rXS擾
	If Len(strCategory) > 0 Then
		strPattern = "//Service[@Category=""" & EscapeString(strCategory) & """]"
	Else
		strPattern = "//Service[not(@Category)]"
	End If
	Set objSvcList = objRoot.selectNodes(strPattern)
	Call Trace(CStr(objSvcList.length) & " services are found in the category """ & strCategory & """")
	For I=0 To objSvcList.length - 1
		Set objService = objSvcList.nextNode
		strSvcName = UnescapeString(objService.getAttribute("Name"))

		' 擾ς݂łȂΔzɒǉ
		bFound = False
		For Each strTmp In arrSvcNames
			If strTmp = strSvcName Then
				bFound = True
			End If
		Next
		If Not bFound Then
			ReDim Preserve arrSvcNames(UBound(arrSvcNames) + 1)
			arrSvcNames(UBound(arrSvcNames)) = strSvcName
		End If
	Next
End Sub


' Ώۂ̃T[rXo^
Sub Register(objArgs)
	Call Trace("Function: Register")
	Dim arrSvcNames()
	Dim strGroup
	Dim strCategory
	Dim I, bSetSvc
	Dim lngTmpCode, strTmpDesc
	ReDim arrSvcNames(-1)

	For I=1 To objArgs.Count - 1
		Select Case Left(objArgs(I), 2)
			Case "-N"	' T[rX̒ڎw
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				If bSetSvc Then
					' -N,-F͂ǂ炩R}hCň񂾂wł
					Call RaiseError(ERROR_SV_TARGETCONFLICT, "More than one -N or -F is specified")
				End If
				ReDim arrSvcNames(0)
				arrSvcNames(0) = Trim(Mid(objArgs(I), 4))
				bSetSvc = True
			Case "-F"	' T[rX񋓂t@Cw
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				If bSetSvc Then
					' -N,-F͂ǂ炩R}hCň񂾂wł
					Call RaiseError(ERROR_SV_TARGETCONFLICT, "More than one -N or -F is specified")
				End If
				' T[rXwt@Cǂݍ
				On Error Resume Next
				Err.Clear
				Call ReadServiceNameFile(Mid(objArgs(I), 4), arrSvcNames)
				lngTmpCode = Err.Number
				strTmpDesc = Err.Description
				On Error Goto 0
				If lngTmpCode <> 0 Then
					Call RaiseError(ERROR_SV_READNAMEFILE, "Cannot read " & Mid(objArgs(I), 4) & ": " & _
						strTmpDesc & "(SubCode=" & CStr(lngTmpCode) & ")")
				End If
				
				bSetSvc = True
			Case "-G"	' O[vw
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				strGroup = Mid(objArgs(I), 4)
			Case "-C"	' JeSw
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				strCategory = Mid(objArgs(I), 4)
			Case Else
				Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
		End Select
	Next

	If UBound(arrSvcNames) < 0 Then
		' T[rX1Ȃ
		Call RaiseError(ERROR_SV_NOTARGET, "No target services")
	End If
	If Len(strGroup) = 0 Then
		' O[vȂ
		Call RaiseError(ERROR_SV_NOGROUP, "Group(-G:) is needed")
	End If

	Call Trace("group: " & strGroup)
	Call Trace("category: " & strCategory)
	Dim strSvcName
	For Each strSvcName In arrSvcNames
		Call Trace("service: " & strSvcName)
	Next

	Call SaveRegisteredServices(strGroup, arrSvcNames, strCategory)
End Sub

' w肵O[v̓o^
Sub Unregister(objArgs)
	Call Trace("Function: Unregister")
	Dim strGroup, I

	For I=1 To objArgs.Count - 1
		Select Case Left(objArgs(I), 2)
			Case "-G"
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				strGroup = Mid(objArgs(I), 4)
			Case Else
				Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
		End Select
	Next

	If Len(strGroup) = 0 Then
		' O[vȂ
		Call RaiseError(ERROR_SV_NOGROUP, "No group")
	End If

	Call Trace("group: " & strGroup)

	Call SaveRegisteredServices(strGroup, Null, "")
End Sub


' ]T[rX܂߂Ē~
Sub StopAllDependents(objWMI, objSvc, byVal lngWait, byVal lngMaxRetry)
	Dim objDepSvcs, objDepSvc, intRet
	Dim bReady, I
	Dim intRetryCount
	Call Trace("Stopping """ & objSvc.DisplayName & """ and all dependents...")
	Set objDepSvcs = objWMI.ExecQuery("Associators of {Win32_Service.Name='" &_
		objSvc.Name & "'} Where AssocClass=Win32_DependentService Role=Antecedent")
	For Each objDepSvc In objDepSvcs
		If objDepSvc.Started Then
			Call StopAllDependents(objWMI, objDepSvc, lngWait, lngMaxRetry)
		End If
	Next

	' ΏۃT[rX~߂
	For intRetryCount=0 To lngMaxRetry
		Call Trace("Stopping """ & objSvc.DisplayName & """")
		intRet = objSvc.StopService
		If intRet = 0 Then
			Exit For
		ElseIf intRet = 11 Then
			' T[rXDBbNĂꍇ̓gC
			Call Trace("StopService failed (Service database locked), Retry...")
		Else
			' ̑̃G[
			Call RaiseError(ERROR_SV_STOPSERVICE, "StopService failed: " &_
				 GetServiceErrorMessage(intRet) & " (" & CStr(intRet) & ")")
		End If
		WScript.Sleep(1000)
	Next
	If intRet <> 0 Then
		' gC񐔓ɐȂ
		Call RaiseError(ERROR_SV_STOPSERVICE, "Retry count exceeded")
	End If

	' T[rX~߂AԂXV܂ōőlngWaitb҂
	Dim objSvcs, objSvcNow
	For I=0 To lngWait
		bReady = True
		Set objSvcs = objWMI.ExecQuery("Select * from Win32_Service where DisplayName='" &_
			objSvc.DisplayName & "'")
		For Each objSvcNow In objSvcs
			If objSvcNow.Started Then
				bReady = False
				Exit For
			End If
		Next
		If bReady Or I >= lngWait Then Exit For
		WScript.Sleep(1000)
	Next
	If Not bReady Then
		' ԓɃT[rX~Ȃ
		Call Trace("WARNING: Timeout...ignored")
	Else
		Call Trace("Stopped(" & CStr(intRet) & ")")
	End If
End Sub


' Ԃ̕ۑƒ~sBłɏ񂪂ΉȂ
Sub SaveAndStopServices(strStateFile, arrSvcNames, byVal lngWait, byVal lngMaxRetry)
	Dim objXML, objFSO, bRet
	Dim objRoot, objGroup, objService
	
	Set objXML = WScript.CreateObject("MSXML.DOMDocument")
	objXML.async = False
	
	' ԕۑt@Cǂݍ
	Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
	If objFSO.FileExists(strStateFile) Then
		' t@C΃[gm[h擾
		Call Trace("Loading state file: " & strStateFile)
		bRet = objXML.load(strStateFile)
		If Not bRet Then
			Call RaiseError(ERROR_SV_READSTATEFILE, "Failed to load state file (bad format)")
		End If
		Set objRoot = objXML.documentElement
		Call Trace("Loading completed")
	Else
		' t@CȂ΃[gm[h쐬
		Call Trace("No services are saved, creating new state file")
		Set objRoot = objXML.createElement("Services")
		Set objXML.documentElement = objRoot
	End If

	Dim objWMI
	Set objWMI = GetObject("winmgmts:\\.\root\cimv2")

	Dim strSvcName, strStartup, strRunning
	Dim objSvcs, objSvc
	Dim intRet
	Dim intRetryCount
	For Each strSvcName In arrSvcNames
		' Ώۂ̃T[rXOS擾
		Set objSvcs = objWMI.ExecQuery("Select * from Win32_Service where DisplayName='" &_
			strSvcName & "'")
		If objSvcs.Count = 0 Then
			Call Trace("Service """ & strSvcName & """ was not found on this machine, skipped")
		End If
		For Each objSvc In objSvcs	' RNV1qbgȂ͂
			Call Trace("Service """ & strSvcname & """ was found")
			Set objService = objRoot.selectSingleNode("./Service[@Name=""" &_
				EscapeString(strSvcName) & """]")
			If objService Is Nothing Then
				' Ȍ񂪖Ƃ̂݌݂̏Ԃۑ
				Set objService = objXML.createElement("Service")
				Call objService.setAttribute("Name", EscapeString(strSvcName))
				Call objService.setAttribute("Startup", EscapeString(objSvc.StartMode))
				Call objService.setAttribute("Running", EscapeString(CStr(objSvc.Started)))
				Call objRoot.appendChild(objService)
				Call Trace("New node for the service was created")
			Else
				Call Trace("The service has been already saved, skipped")
			End If
		Next
	Next
	' ԕۑt@CXV
	Dim strSave
	Call Trace("Saving state file")
	strSave = SaveXML(objXML, strStateFile)
	If strSave <> "" Then
		Call RaiseError(ERROR_SV_WRITESTATEFILE, "Failed to save state file: " & strSave)
	End If
	Call Trace("Saving completed")

	' T[rX~߂
	' ˑ֌Ŵꍇlĕۑƃ[v𕪂
	Call Trace("Suppressing auto-startup setting and stopping the services")
	For Each strSvcName In arrSvcNames
		' Ώۂ̃T[rXOS擾
		Set objSvcs = objWMI.ExecQuery("Select * from Win32_Service where DisplayName='" &_
			strSvcName & "'")
		If objSvcs.Count = 0 Then
			Call Trace("Service """ & strSvcName & """ was not found on this machine, skipped")
		End If
		For Each objSvc In objSvcs	' RNV1qbgȂ͂
			' ݂̗Lɂ炸N}~ƃT[rX~
			If objSvc.StartMode = "Auto" Then
				' Ȃ蓮ɂB̑͂Ȃ
				Call Trace("Changing StartMode of """ & strSvcName & """ to Manual")
				For intRetryCount=0 To lngMaxRetry
					intRet = objSvc.ChangeStartMode("Manual")
					If intRet = 0 Then
						Call Trace("Changed(" & intRet & ")")
						Exit For
					
					ElseIf intRet = 11 Then
						' T[rXDBbNĂꍇ̓gC
						Call Trace("ChangeStartMode(Manual) failed (Service database locked), Retry...")
						
					Else
						' ̑̃G[
						Call RaiseError(ERROR_SV_SUPPRESSSTARTUP, "ChangeStartMode(Manual) failed: " &_
							GetServiceErrorMessage(intRet) & " (" & CStr(intRet) & ")")
					End If
					WScript.Sleep(1000)
				Next
				If intRet <> 0 Then
					' gC񐔓ɐȂ
					Call RaiseError(ERROR_SV_SUPPRESSSTARTUP, "Retry count exceeded")
				End If

			End If
			If objSvc.Started Then
				' w肵T[rX̏]T[rXƒ~
				Call StopAllDependents(objWMI, objSvc, lngWait, lngMaxRetry)
			End If
		Next
	Next
	Call Trace("Suppressing and stopping completed")
End Sub


' Ԃ̕ۑƋN}~sBłɏ񂪂ΉȂ
Sub DoSuppressStartup(strStateFile, arrSvcNames, byVal lngMaxRetry)
	Dim objXML, objFSO, bRet
	Dim objRoot, objGroup, objService
	
	Set objXML = WScript.CreateObject("MSXML.DOMDocument")
	objXML.async = False
	
	' ԕۑt@Cǂݍ
	Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
	If objFSO.FileExists(strStateFile) Then
		' t@C΃[gm[h擾
		Call Trace("Loading state file: " & strStateFile)
		bRet = objXML.load(strStateFile)
		If Not bRet Then
			Call RaiseError(ERROR_SV_READSTATEFILE, "Failed to load state file (bad format)")
		End If
		Set objRoot = objXML.documentElement
		Call Trace("Loading completed")
	Else
		' t@CȂ΃[gm[h쐬
		Call Trace("No services are saved, creating new state file")
		Set objRoot = objXML.createElement("Services")
		Set objXML.documentElement = objRoot
	End If

	Dim objWMI
	Set objWMI = GetObject("winmgmts:\\.\root\cimv2")

	Dim strSvcName, strStartup, strRunning
	Dim objSvcs, objSvc
	Dim intRet
	Dim intRetryCount
	For Each strSvcName In arrSvcNames
		' Ώۂ̃T[rXOS擾
		Set objSvcs = objWMI.ExecQuery("Select * from Win32_Service where DisplayName='" &_
			strSvcName & "'")
		If objSvcs.Count = 0 Then
			Call Trace("Service """ & strSvcName & """ was not found on this machine, skipped")
		End If
		For Each objSvc In objSvcs	' RNV1qbgȂ͂
			Call Trace("Service """ & strSvcname & """ was found")
			Set objService = objRoot.selectSingleNode("./Service[@Name=""" &_
				EscapeString(strSvcName) & """]")
			If objService Is Nothing Then
				' Ȍ񂪖Ƃ̂݌݂̏Ԃۑ
				Set objService = objXML.createElement("Service")
				Call objService.setAttribute("Name", EscapeString(strSvcName))
				Call objService.setAttribute("Startup", EscapeString(objSvc.StartMode))
				Call objService.setAttribute("Running", EscapeString(CStr(objSvc.Started)))
				Call objRoot.appendChild(objService)
				Call Trace("New node for the service was created")
			Else
				Call Trace("The service has been already saved, skipped")
			End If
		Next
	Next
	' ԕۑt@CXV
	Dim strSave
	Call Trace("Saving state file")
	strSave = SaveXML(objXML, strStateFile)
	If strSave <> "" Then
		Call RaiseError(ERROR_SV_WRITESTATEFILE, "Failed to save state file: " & strSave)
	End If
	Call Trace("Saving completed")

	' T[rX̎N}~
	Call Trace("Suppressing auto-startup setting")
	For Each strSvcName In arrSvcNames
		' Ώۂ̃T[rXOS擾
		Set objSvcs = objWMI.ExecQuery("Select * from Win32_Service where DisplayName='" &_
			strSvcName & "'")
		If objSvcs.Count = 0 Then
			Call Trace("Service """ & strSvcName & """ was not found on this machine, skipped")
		End If
		For Each objSvc In objSvcs	' RNV1qbgȂ͂
			' ݂̗Lɂ炸N}~
			If objSvc.StartMode = "Auto" Then
				' Ȃ蓮ɂB̑͂Ȃ
				Call Trace("Changing StartMode of """ & strSvcName & """ to Manual")
				For intRetryCount=0 To lngMaxRetry
					intRet = objSvc.ChangeStartMode("Manual")
					If intRet = 0 Then
						Call Trace("Changed(" & intRet & ")")
						Exit For
					
					ElseIf intRet = 11 Then
						' T[rXDBbNĂꍇ̓gC
						Call Trace("ChangeStartMode(Manual) failed (Service database locked), Retry...")
						
					Else
						' ̑̃G[
						Call RaiseError(ERROR_SV_SUPPRESSSTARTUP, "ChangeStartMode(Manual) failed: " &_
							GetServiceErrorMessage(intRet) & " (" & CStr(intRet) & ")")
					End If
					WScript.Sleep(1000)
				Next
				If intRet <> 0 Then
					' gC񐔓ɐȂ
					Call RaiseError(ERROR_SV_SUPPRESSSTARTUP, "Retry count exceeded")
				End If

			End If
		Next
	Next
	Call Trace("Suppressing the services has completed")
End Sub


' T[rX̒~s
Sub DoStopServices(arrSvcNames, byVal lngWait, byVal lngMaxRetry)
	Dim objWMI
	Set objWMI = GetObject("winmgmts:\\.\root\cimv2")

	Dim strSvcName
	Dim objSvcs, objSvc

	' T[rX~߂
	Call Trace("Stopping the services")
	For Each strSvcName In arrSvcNames
		' Ώۂ̃T[rXOS擾
		Set objSvcs = objWMI.ExecQuery("Select * from Win32_Service where DisplayName='" &_
			strSvcName & "'")
		If objSvcs.Count = 0 Then
			Call Trace("Service """ & strSvcName & """ was not found on this machine, skipped")
		End If
		For Each objSvc In objSvcs	' RNV1qbgȂ͂
			' T[rX~
			If objSvc.Started Then
				' w肵T[rX̏]T[rXƒ~
				Call StopAllDependents(objWMI, objSvc, lngWait, lngMaxRetry)
			End If
		Next
	Next
	Call Trace("Stopping the services has completed")
End Sub


' Ԃ̕ƍĊJs
Sub RestoreAndStartServices(strStateFile, arrSvcNames, byVal lngMaxRetry)
	Dim objXML, objFSO, bRet
	Dim objRoot, objGroup, objService
	Dim intRetryCount

	Set objXML = WScript.CreateObject("MSXML.DOMDocument")
	objXML.async = False

	Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
	If Not objFSO.FileExists(strStateFile) Then
		' ۑɕ͂肦Ȃ̂ŃG[
		Call RaiseError(ERROR_SV_NOSTATEFILE, "State file is not exists: " & strStateFile)
	End If
	
	' ԕۑt@Cǂݍ
	Call Trace("Loading state file: " & strStateFile)
	bRet = objXML.load(strStateFile)
	If Not bRet Then
		Call RaiseError(ERROR_SV_READSTATEFILE, "Failed to load state file (bad format)")
	End If
	Set objRoot = objXML.documentElement
	Call Trace("Loading completed")

	Call Trace("Restoring auto-startup setting and starting the services")
	Dim objWMI
	Set objWMI = GetObject("winmgmts:\\.\root\cimv2")

	Dim strSvcName, strStartup, strRunning
	Dim objSvcs, objSvc
	Dim strMode, intRet

	For Each strSvcName In arrSvcNames
		Set objSvcs = objWMI.ExecQuery("Select * from Win32_Service where DisplayName='" &_
			strSvcName & "'")
		If objSvcs.Count = 0 Then
			Call Trace("Service """ & strSvcName & """ was not found on this machine, skipped")
		End If
		For Each objSvc In objSvcs	' 1qbgȂ͂
			Set objService = objRoot.selectSingleNode("./Service[@Name=""" &_
				EscapeString(strSvcName) & """]")
			If Not objService Is Nothing Then
				' 񂪂Ƃ̂
				' Nݒ̕
				Select Case objService.getAttribute("Startup")
					Case "Auto"
						strMode = "Automatic"
					Case "Manual"
						strMode = "Manual"
					Case "Disabled"
						strMode = "Disabled"
					Case Else
						Call RaiseError(ERROR_SV_BADSTATEFILE, "Invalid startup mode: " & strSvcName)
				End Select
				If objSvc.StartMode <> objService.getAttribute("Startup") Then
					Call Trace("Changing StartMode of """ & strSvcName & """ to " & strMode)
					For intRetryCount=0 To lngMaxRetry
						intRet = objSvc.ChangeStartMode(strMode)
						If intRet = 0 Then
							Call Trace("Changed(" & CStr(intRet) & ")")
							Exit For
						
						ElseIf intRet = 11 Then
							' T[rXDBbNĂꍇ̓gC
							Call Trace("ChangeStartMode(" & strMode & ") failed (Service database locked), Retry...")
							
						Else
							' ̑̃G[
							Call RaiseError(ERROR_SV_RESTORESTARTUP, "ChangeStartMode(" & strMode & ") failed: " &_
								GetServiceErrorMessage(intRet) & " (" & CStr(intRet) & ")")
						End If
						WScript.Sleep(1000)
					Next
					If intRet <> 0 Then
						' gC񐔓ɐȂ
						Call RaiseError(ERROR_SV_RESTORESTARTUP, "Retry count exceeded")
					End If
				End If

				' sԂ̕
				' ۑɋNĂāAɎsł͂ȂANݒ肪uvł͂ȂƂ̂݋N݂
				If objService.getAttribute("Running") = "True" And _
					Not objSvc.Started And objSvc.StartMode <> "Disabled" Then

					For intRetryCount=0 To lngMaxRetry
						Call Trace("Starting """ & strSvcName & """")
						intRet = objSvc.StartService
						If intRet = 0 Then
							Call Trace("Started(" & CStr(intRet) & ")")
							Exit For
							
						ElseIf intRet = 11 Then
							' T[rXDBbNĂꍇ̓gC
							Call Trace("StartService failed (Service database locked), Retry...")
						Else
							' ̑̃G[
							Call RaiseError(ERROR_SV_STARTSERVICE, "StartService failed: " &_
								GetServiceErrorMessage(intRet) & " (" & CStr(intRet) & ")")
						End If
						WScript.Sleep(1000)
					Next
							
					If intRet <> 0 Then
						' gC񐔓ɐȂ
						Call RaiseError(ERROR_SV_STARTSERVICE, "Retry count exceeded")
					End If
				End If
				' 폜
				Call objRoot.removeChild(objService)
			Else
				' ۑĂȂ
				Call Trace("Service """ & strSvcName & """ has not been saved or already restored... skipped")
			End If
		Next
	Next
	Call Trace("Restoring completed")

	' ԕۑt@CXV
	Dim strSave
	Call Trace("Saving state file")
	strSave = SaveXML(objXML, strStateFile)
	If strSave <> "" Then
		Call RaiseError(ERROR_SV_WRITESTATEFILE, "Failed to save state file: " & strSave)
	End If
	Call Trace("Saving completed")
End Sub


Sub DoRestoreStartup(strStateFile, arrSvcNames, byVal lngMaxRetry)
	Dim objXML, objFSO, bRet
	Dim objRoot, objGroup, objService
	Dim intRetryCount

	Set objXML = WScript.CreateObject("MSXML.DOMDocument")
	objXML.async = False

	Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
	If Not objFSO.FileExists(strStateFile) Then
		' ۑɕ͂肦Ȃ̂ŃG[
		Call RaiseError(ERROR_SV_NOSTATEFILE, "State file is not exists: " & strStateFile)
	End If
	
	' ԕۑt@Cǂݍ
	Call Trace("Loading state file: " & strStateFile)
	bRet = objXML.load(strStateFile)
	If Not bRet Then
		Call RaiseError(ERROR_SV_READSTATEFILE, "Failed to load state file (bad format)")
	End If
	Set objRoot = objXML.documentElement
	Call Trace("Loading completed")

	Call Trace("Restoring auto-startup setting")
	Dim objWMI
	Set objWMI = GetObject("winmgmts:\\.\root\cimv2")

	Dim strSvcName, strStartup, strRunning
	Dim objSvcs, objSvc
	Dim strMode, intRet

	For Each strSvcName In arrSvcNames
		Set objSvcs = objWMI.ExecQuery("Select * from Win32_Service where DisplayName='" &_
			strSvcName & "'")
		If objSvcs.Count = 0 Then
			Call Trace("Service """ & strSvcName & """ was not found on this machine, skipped")
		End If
		For Each objSvc In objSvcs	' 1qbgȂ͂
			Set objService = objRoot.selectSingleNode("./Service[@Name=""" &_
				EscapeString(strSvcName) & """ and @Startup]")
			If Not objService Is Nothing Then
				' 񂪂Ƃ̂
				' Nݒ̕
				Select Case objService.getAttribute("Startup")
					Case "Auto"
						strMode = "Automatic"
					Case "Manual"
						strMode = "Manual"
					Case "Disabled"
						strMode = "Disabled"
					Case Else
						Call RaiseError(ERROR_SV_BADSTATEFILE, "Invalid startup mode: " & strSvcName)
				End Select
				If objSvc.StartMode <> objService.getAttribute("Startup") Then
					Call Trace("Changing StartMode of """ & strSvcName & """ to " & strMode)
					For intRetryCount=0 To lngMaxRetry
						intRet = objSvc.ChangeStartMode(strMode)
						If intRet = 0 Then
							Call Trace("Changed(" & CStr(intRet) & ")")
							Exit For
						
						ElseIf intRet = 11 Then
							' T[rXDBbNĂꍇ̓gC
							Call Trace("ChangeStartMode(" & strMode & ") failed (Service database locked), Retry...")
							
						Else
							' ̑̃G[
							Call RaiseError(ERROR_SV_RESTORESTARTUP, "ChangeStartMode(" & strMode & ") failed: " &_
								GetServiceErrorMessage(intRet) & " (" & CStr(intRet) & ")")
						End If
						WScript.Sleep(1000)
					Next
					If intRet <> 0 Then
						' gC񐔓ɐȂ
						Call RaiseError(ERROR_SV_RESTORESTARTUP, "Retry count exceeded")
					End If
				End If

				' Nݒ폜
				Call objService.removeAttribute("Startup")
			Else
				' ۑĂȂ
				Call Trace("Service """ & strSvcName & """ has not been saved or already restored... skipped")
			End If
		Next
	Next
	Call Trace("Restoring completed")

	' ԕۑt@CXV
	Dim strSave
	Call Trace("Saving state file")
	strSave = SaveXML(objXML, strStateFile)
	If strSave <> "" Then
		Call RaiseError(ERROR_SV_WRITESTATEFILE, "Failed to save state file: " & strSave)
	End If
	Call Trace("Saving completed")
End Sub


Sub DoStartServices(strStateFile, arrSvcNames, byVal lngMaxRetry)
	Dim objXML, objFSO, bRet
	Dim objRoot, objGroup, objService
	Dim intRetryCount

	Set objXML = WScript.CreateObject("MSXML.DOMDocument")
	objXML.async = False

	Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
	If Not objFSO.FileExists(strStateFile) Then
		' ۑɕ͂肦Ȃ̂ŃG[
		Call RaiseError(ERROR_SV_NOSTATEFILE, "State file is not exists: " & strStateFile)
	End If
	
	' ԕۑt@Cǂݍ
	Call Trace("Loading state file: " & strStateFile)
	bRet = objXML.load(strStateFile)
	If Not bRet Then
		Call RaiseError(ERROR_SV_READSTATEFILE, "Failed to load state file (bad format)")
	End If
	Set objRoot = objXML.documentElement
	Call Trace("Loading completed")

	Call Trace("Starting the services")
	Dim objWMI
	Set objWMI = GetObject("winmgmts:\\.\root\cimv2")

	Dim strSvcName, strStartup, strRunning
	Dim objSvcs, objSvc
	Dim strMode, intRet

	For Each strSvcName In arrSvcNames
		Set objSvcs = objWMI.ExecQuery("Select * from Win32_Service where DisplayName='" &_
			strSvcName & "'")
		If objSvcs.Count = 0 Then
			Call Trace("Service """ & strSvcName & """ was not found on this machine, skipped")
		End If
		For Each objSvc In objSvcs	' 1qbgȂ͂
			Set objService = objRoot.selectSingleNode("./Service[@Name=""" &_
				EscapeString(strSvcName) & """ and @Running]")
			If Not objService Is Nothing Then
				' 񂪂Ƃ̂
				' sԂ̕
				' ۑɋNĂāAɎsł͂ȂANݒ肪uvł͂ȂƂ̂݋N݂
				If objService.getAttribute("Running") = "True" And _
					Not objSvc.Started And objSvc.StartMode <> "Disabled" Then

					For intRetryCount=0 To lngMaxRetry
						Call Trace("Starting """ & strSvcName & """")
						intRet = objSvc.StartService
						If intRet = 0 Then
							Call Trace("Started(" & CStr(intRet) & ")")
							Exit For
							
						ElseIf intRet = 11 Then
							' T[rXDBbNĂꍇ̓gC
							Call Trace("StartService failed (Service database locked), Retry...")
						Else
							' ̑̃G[
							Call RaiseError(ERROR_SV_STARTSERVICE, "StartService failed: " &_
								GetServiceErrorMessage(intRet) & " (" & CStr(intRet) & ")")
						End If
						WScript.Sleep(1000)
					Next
							
					If intRet <> 0 Then
						' gC񐔓ɐȂ
						Call RaiseError(ERROR_SV_STARTSERVICE, "Retry count exceeded")
					End If
				End If
				' 폜
				Call objRoot.removeChild(objService)
			Else
				' ۑĂȂ
				Call Trace("Service """ & strSvcName & """ has not been saved or already restored... skipped")
			End If
		Next
	Next
	Call Trace("Starting the services has completed")

	' ԕۑt@CXV
	Dim strSave
	Call Trace("Saving state file")
	strSave = SaveXML(objXML, strStateFile)
	If strSave <> "" Then
		Call RaiseError(ERROR_SV_WRITESTATEFILE, "Failed to save state file: " & strSave)
	End If
	Call Trace("Saving completed")
End Sub


' ۑƒ~̃R}h
Sub SaveAndStop(objArgs)
	Call Trace("Function: SaveAndStop")
	Dim lngWait, lngMaxRetry, strStateFile, I
	Dim strScript, nLastBS
	Dim strCategory
	Dim arrSvcNames()
	
	lngWait = lngDefWait
	lngMaxRetry = lngDefMaxRetry

	' ftHg̏ԕۑt@C̓XNvgƓfBNgɒu
	strScript = WScript.ScriptFullName
	nLastBS = InStrRev(strScript, "\")
	strStateFile = Left(strScript, nLastBS) & strDefStateFile

	For I=1 To objArgs.Count - 1
		Select Case Left(objArgs(I), 2)
			Case "-O"
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				strStateFile = Mid(objArgs(I), 4)
				
			Case "-W"
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				On Error Resume Next
				lngWait = CLng(Mid(objArgs(I), 4))
				If Err <> 0 Then lngWait = -1
				On Error Goto 0
				If lngWait < 0 Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				
			Case "-R"
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				On Error Resume Next
				lngMaxRetry = CLng(Mid(objArgs(I), 4))
				If Err <> 0 Then lngMaxRetry = -1
				On Error Goto 0
				If lngMaxRetry < 0 Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				
			Case "-C"	' JeSw
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				strCategory = Mid(objArgs(I), 4)

			Case Else
				Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
		End Select
	Next

	Call LoadRegisteredServices(arrSvcNames, strCategory)

	Call Trace("state file: " & strStateFile)
	Dim strSvc
	For Each strSvc In arrSvcNames
		Call Trace("target: " & strSvc)
	Next

	Call SaveAndStopServices(strStateFile, arrSvcNames, lngWait, lngMaxRetry)
End Sub


' ۑƋN}~̃R}h
Sub SuppressStartup(objArgs)
	Call Trace("Function: SuppressStartup")
	Dim lngMaxRetry, strStateFile, I
	Dim strScript, nLastBS
	Dim strCategory
	Dim arrSvcNames()
	
	lngMaxRetry = lngDefMaxRetry

	' ftHg̏ԕۑt@C̓XNvgƓfBNgɒu
	strScript = WScript.ScriptFullName
	nLastBS = InStrRev(strScript, "\")
	strStateFile = Left(strScript, nLastBS) & strDefStateFile

	For I=1 To objArgs.Count - 1
		Select Case Left(objArgs(I), 2)
			Case "-O"
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				strStateFile = Mid(objArgs(I), 4)
				
			Case "-R"
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				On Error Resume Next
				lngMaxRetry = CLng(Mid(objArgs(I), 4))
				If Err <> 0 Then lngMaxRetry = -1
				On Error Goto 0
				If lngMaxRetry < 0 Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				
			Case "-C"	' JeSw
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				strCategory = Mid(objArgs(I), 4)

			Case Else
				Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
		End Select
	Next

	Call LoadRegisteredServices(arrSvcNames, strCategory)

	Call Trace("state file: " & strStateFile)
	Dim strSvc
	For Each strSvc In arrSvcNames
		Call Trace("target: " & strSvc)
	Next

	Call DoSuppressStartup(strStateFile, arrSvcNames, lngMaxRetry)
End Sub


' ~̃R}h
Sub StopServices(objArgs)
	Call Trace("Function: StopServices")
	Dim lngWait, lngMaxRetry, I
	Dim strScript
	Dim strCategory
	Dim arrSvcNames()
	
	lngWait = lngDefWait
	lngMaxRetry = lngDefMaxRetry

	' ftHg̏ԕۑt@C̓XNvgƓfBNgɒu
	strScript = WScript.ScriptFullName

	For I=1 To objArgs.Count - 1
		Select Case Left(objArgs(I), 2)
			Case "-W"
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				On Error Resume Next
				lngWait = CLng(Mid(objArgs(I), 4))
				If Err <> 0 Then lngWait = -1
				On Error Goto 0
				If lngWait < 0 Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				
			Case "-R"
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				On Error Resume Next
				lngMaxRetry = CLng(Mid(objArgs(I), 4))
				If Err <> 0 Then lngMaxRetry = -1
				On Error Goto 0
				If lngMaxRetry < 0 Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				
			Case "-C"	' JeSw
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				strCategory = Mid(objArgs(I), 4)

			Case Else
				Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
		End Select
	Next

	Call LoadRegisteredServices(arrSvcNames, strCategory)

	Dim strSvc
	For Each strSvc In arrSvcNames
		Call Trace("target: " & strSvc)
	Next

	Call DoStopServices(arrSvcNames, lngWait, lngMaxRetry)
End Sub


' ƍĊJ̃R}h
Sub RestoreAndStart(objArgs)
	Call Trace("Function: RestoreAndStart")
	Dim lngMaxRetry, strStateFile, I
	Dim strScript, nLastBS
	Dim strCategory
	Dim arrSvcNames()
	
	lngMaxRetry = lngDefMaxRetry

	' ftHg̏ԕۑt@C̓XNvgƓfBNgɒu
	strScript = WScript.ScriptFullName
	nLastBS = InStrRev(strScript, "\")
	strStateFile = Left(strScript, nLastBS) & strDefStateFile

	For I=1 To objArgs.Count - 1
		Select Case Left(objArgs(I), 2)
			Case "-O"
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				strStateFile = Mid(objArgs(I), 4)
				
			Case "-R"
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				On Error Resume Next
				lngMaxRetry = CLng(Mid(objArgs(I), 4))
				If Err <> 0 Then lngMaxRetry = -1
				On Error Goto 0
				If lngMaxRetry < 0 Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				
			Case "-C"	' JeSw
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				strCategory = Mid(objArgs(I), 4)

			Case Else
				Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
		End Select
	Next

	Call LoadRegisteredServices(arrSvcNames, strCategory)

	Call Trace("state file: " & strStateFile)
	Dim strSvc
	For Each strSvc In arrSvcNames
		Call Trace("target: " & strSvc)
	Next

	Call RestoreAndStartServices(strStateFile, arrSvcNames, lngMaxRetry)
End Sub


' ̃R}h
Sub RestoreStartup(objArgs)
	Call Trace("Function: RestoreStartup")
	Dim lngMaxRetry, strStateFile, I
	Dim strScript, nLastBS
	Dim strCategory
	Dim arrSvcNames()
	
	lngMaxRetry = lngDefMaxRetry

	' ftHg̏ԕۑt@C̓XNvgƓfBNgɒu
	strScript = WScript.ScriptFullName
	nLastBS = InStrRev(strScript, "\")
	strStateFile = Left(strScript, nLastBS) & strDefStateFile

	For I=1 To objArgs.Count - 1
		Select Case Left(objArgs(I), 2)
			Case "-O"
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				strStateFile = Mid(objArgs(I), 4)
				
			Case "-R"
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				On Error Resume Next
				lngMaxRetry = CLng(Mid(objArgs(I), 4))
				If Err <> 0 Then lngMaxRetry = -1
				On Error Goto 0
				If lngMaxRetry < 0 Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				
			Case "-C"	' JeSw
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				strCategory = Mid(objArgs(I), 4)

			Case Else
				Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
		End Select
	Next

	Call LoadRegisteredServices(arrSvcNames, strCategory)

	Call Trace("state file: " & strStateFile)
	Dim strSvc
	For Each strSvc In arrSvcNames
		Call Trace("target: " & strSvc)
	Next

	Call DoRestoreStartup(strStateFile, arrSvcNames, lngMaxRetry)
End Sub


' ĊJ̃R}h
Sub StartServices(objArgs)
	Call Trace("Function: StartServices")
	Dim lngMaxRetry, strStateFile, I
	Dim strScript, nLastBS
	Dim strCategory
	Dim arrSvcNames()
	
	lngMaxRetry = lngDefMaxRetry

	' ftHg̏ԕۑt@C̓XNvgƓfBNgɒu
	strScript = WScript.ScriptFullName
	nLastBS = InStrRev(strScript, "\")
	strStateFile = Left(strScript, nLastBS) & strDefStateFile

	For I=1 To objArgs.Count - 1
		Select Case Left(objArgs(I), 2)
			Case "-O"
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				strStateFile = Mid(objArgs(I), 4)
				
			Case "-R"
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				On Error Resume Next
				lngMaxRetry = CLng(Mid(objArgs(I), 4))
				If Err <> 0 Then lngMaxRetry = -1
				On Error Goto 0
				If lngMaxRetry < 0 Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				
			Case "-C"	' JeSw
				If Len(objArgs(I)) < 4 Or Mid(objArgs(I), 3, 1) <> ":" Then
					Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
				End If
				strCategory = Mid(objArgs(I), 4)

			Case Else
				Call RaiseError(ERROR_SV_BADOPTION, "Invalid option: """ & objArgs(I) & """")
		End Select
	Next

	Call LoadRegisteredServices(arrSvcNames, strCategory)

	Call Trace("state file: " & strStateFile)
	Dim strSvc
	For Each strSvc In arrSvcNames
		Call Trace("target: " & strSvc)
	Next

	Call DoStartServices(strStateFile, arrSvcNames, lngMaxRetry)
End Sub


' T[rẌꗗ쐬
Sub ListServices(objArgs)
	Call Trace("Function: ListServices")
	Dim objWMI
	Set objWMI = GetObject("winmgmts:\\.\root\cimv2")

	Dim objSvcs, objSvc
	Set objSvcs = objWMI.ExecQuery("select * from Win32_Service")
	For Each objSvc In objSvcs
		WScript.StdOut.WriteLine(objSvc.DisplayName)
	Next
End Sub


Sub Main(objArgs)
	' ȂΎgp@\ďI
	If objArgs.Count = 0 Then
		Call Usage
		WScript.Quit(0)
	End If

	Call Trace("--- START ---")
	' ŏ̈œw
	Dim strSubCmd
	strSubCmd = LCase(objArgs(0))
	Select Case strSubCmd
		Case "register"
			Call Register(objArgs)
		Case "unregister"
			Call Unregister(objArgs)
		Case "saveandstop"
			Call SaveAndStop(objArgs)
		Case "restoreandstart"
			Call RestoreAndStart(objArgs)
		Case "suppressstartup"
			Call SuppressStartup(objArgs)
		Case "stopservices"
			Call StopServices(objArgs)
		Case "restorestartup"
			Call RestoreStartup(objArgs)
		Case "startservices"
			Call StartServices(objArgs)
		Case "listservices"
			Call ListServices(objArgs)
		Case Else
			Call RaiseError(ERROR_SV_BADCOMMAND, "Invalid command: """ & strSubCmd & """")
	End Select
End Sub



On Error Resume Next
Dim nCode, strMsg

Call Main(WScript.Arguments)
If Err < 0 Then
	' RaiseErrorŔG[
	nCode = Err.Number - vbObjectError

ElseIf Err > 0 Then
	' VBScript̎sG[
	strMsg = "RUNTIME ERROR(" & Err.Number & "): " & Err.Description
	Call Trace(strMsg)
	WScript.Echo(strMsg)
	nCode = Err.Number

Else
	' 
	Call Trace("Succeeded")
	nCode = 0
End If

WScript.Quit(nCode)
