@ECHO OFF
rem
rem Copyright 2010 FUJITSU LIMITED
rem
SETLOCAL

set MAIN_CMD_NAME=%~n0
set INST_DIR=%IS_HOME%
set COMMON_PATH=%INST_DIR%\var\clone
set TARGET_PATH=%COMMON_PATH%\backup
set LOCKFILE=%INST_DIR%\var\%MAIN_CMD_NAME%.lck
set LOG_PATH=%COMMON_PATH%\log
set LOGFILE=%LOG_PATH%\%MAIN_CMD_NAME%.log
set LOCKING=yes

set localHost=
set ipAddr=

IF "%INST_DIR%" == "" (
    ECHO IS: ERROR: is31811: A system error occurred^(Environment variable IS_HOME is not set^)
    EXIT 1
    ENDLOCAL
)

IF NOT EXIST "%INST_DIR%\bin\isstat.exe" (
    ECHO IS: ERROR: is31811: A system error occurred^(%MAIN_CMD_NAME% cannot execute on this environment^)
    EXIT 1
    ENDLOCAL
)

FOR /F %%I in ('%INST_DIR%\bin\isstat 2^>^&1 ^| find /c "is30181"') DO (
    IF NOT %%I == 0 (
        ECHO IS: ERROR: is31804: There was not authority
        EXIT 1
        ENDLOCAL
    )
)

call :LOCKED %* 0>>%LOCKFILE%
IF "%LOCKING%" == "yes" (
    ECHO IS: ERROR: is31812: Other process is also executing %MAIN_CMD_NAME%
    EXIT 1
    ENDLOCAL
)
set RTN=%ERRORLEVEL%
DEL /F /Q %LOCKFILE% > NUL 2>&1
EXIT %RTN%
ENDLOCAL

:LOCKED

rem Parameter Check START
IF "%4" == "" (
    ECHO IS: ERROR: is31802: Required command argument is missing
    goto ERROR_PRE
)

IF NOT "%5" == "" (
    goto ERROR_PRM
)

IF "%1" == "-h" set localHost=%2
IF "%1" == "-i" set ipAddr=%2
IF "%3" == "-h" set localHost=%4
IF "%3" == "-i" set ipAddr=%4

IF "%localHost%" == "" goto ERROR_PRM
IF "%ipAddr%" == "" goto ERROR_PRM
rem Parameter Check END

ECHO IS: INFO: is31805: %MAIN_CMD_NAME% has been started
set STARTTIME=%DATE:~-10% %TIME:~0,8%

IF NOT EXIST %COMMON_PATH% (
    ECHO IS: ERROR: is31811: A system error occurred^(Directory does not exist^(path=%COMMON_PATH%^)^)
    goto ERROR_RTN
)

IF NOT EXIST %TARGET_PATH% (
    ECHO IS: ERROR: is31811: A system error occurred^(Directory does not exist^(path=%TARGET_PATH%^)^)
    goto ERROR_RTN
)

IF NOT EXIST %LOG_PATH% (
    MD "%LOG_PATH%"
    IF ERRORLEVEL 1 (
        ECHO IS: ERROR: is31801: Making the directory was failed^(path=%LOG_PATH%^)
        goto ERROR_RTN
    )
)

ECHO [%STARTTIME%] IS: INFO: is31805: %MAIN_CMD_NAME% has been started>%LOGFILE%

call %~dp0\isswcmimportimg.bat post %localHost%
IF ERRORLEVEL 1 (
    goto ERROR_RTN_LOG
)

:NORMAL_END
ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31806: %MAIN_CMD_NAME% has been finished normally>>%LOGFILE%
ECHO IS: INFO: is31806: %MAIN_CMD_NAME% has been finished normally
set LOCKING=no
EXIT /B 0
ENDLOCAL

:ERROR_RTN_LOG
ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31807: An error has occurred while processing %MAIN_CMD_NAME%>>%LOGFILE%
ECHO IS: ERROR: is31807: An error has occurred while processing %MAIN_CMD_NAME%
set LOCKING=no
EXIT /B 1
ENDLOCAL

:ERROR_RTN
ECHO IS: ERROR: is31807: An error has occurred while processing %MAIN_CMD_NAME%
set LOCKING=no
EXIT /B 1
ENDLOCAL

:ERROR_PRM
ECHO IS: ERROR: is31803: Command argument was invalid^(%*^)
goto ERROR_PRE

:ERROR_PRE
set LOCKING=no
EXIT /B 1
ENDLOCAL
