@ECHO OFF
SETLOCAL
rem ==========================================================================
rem
rem Copyright 2010 FUJITSU LIMITED
rem
rem ==========================================================================
rem <Function>
rem  isswcmexportimg.bat
rem
rem <Function Specification>
rem  To backup or export the resource at once, use this batch file.
rem
rem <Parameter>
rem  None
rem
rem <Return Value>
rem  0 : normal
rem  1 : abnormal
rem
rem <Notice>
rem
rem
rem ==========================================================================

set THIS_CMD_NAME=%~n0

rem ==========================================================================
:DEFINITION_PART
rem ==========================================================================
rem [Common]
rem set INST_DIR=%IS_HOME%
rem set COMMON_PATH=%IS_HOME%\var\rc
rem set TARGET_PATH=%COMMON_PATH%\backup
rem set LOG_PATH=%COMMON_PATH%\log
rem set LOGFILE=%LOG_PATH%\isrcexportimg.log
set INFOFILE=%LOG_PATH%\%MAIN_CMD_NAME%_env.log
set SCW_PREP_SERVICE_LOG=%LOG_PATH%\%MAIN_CMD_NAME%_svctrace.log
set SVCTRACEFILE=%SCW_PREP_SERVICE_LOG%
rem --------------------------------------------------------------------------
rem [ISCOM]
    IF EXIST "%INST_DIR%\bin\iscbackupsys.exe" (
        set ISCOM_TARGET=on
    ) ELSE (
        IF EXIST "%INST_DIR%\td\bin\iscbackupsys.exe" (
            set ISCOM_TARGET=on
        ) ELSE (
            set ISCOM_TARGET=off
        )
    )
rem --------------------------------------------------------------------------
rem [GUI]
rem IF EXIST "%INST_DIR%\gui\etc\config" (
rem     set GUI_TARGET=on
rem ) ELSE (
        set GUI_TARGET=off
rem )
rem --------------------------------------------------------------------------
rem [JMX]
rem IF EXIST "%INST_DIR%\lib\isjmxadmin.jar" (
rem     set JMX_TARGET=on
rem ) ELSE (
        set JMX_TARGET=off
rem )
rem --------------------------------------------------------------------------
rem [OD]
    IF EXIST "%INST_DIR%\ODWIN\bin\odbackupsys.exe" (
        set OD_TARGET=on
    ) ELSE (
        set OD_TARGET=off
    )
rem --------------------------------------------------------------------------
rem [ES]
rem IF EXIST "%INST_DIR%\bin\esdmnmain.exe" (
rem     set ES_TARGET=on
rem ) ELSE (
rem     IF EXIST "%INST_DIR%\eswin\bin\esdmnmain.exe" (
rem         set ES_TARGET=on
rem     ) ELSE (
            set ES_TARGET=off
rem     )
rem )
rem --------------------------------------------------------------------------
rem [TD]
rem IF EXIST "%INST_DIR%\bin\tdbackupsys.exe" (
rem     set TD_TARGET=on
rem ) ELSE (
rem     IF EXIST "%INST_DIR%\td\bin\tdbackupsys.exe" (
rem         set TD_TARGET=on
rem     ) ELSE (
            set TD_TARGET=off
rem     )
rem )
rem --------------------------------------------------------------------------
rem [OTS]
rem IF EXIST "%INST_DIR%\ots\etc\sysconfig" (
rem     set OTS_TARGET=on
rem ) ELSE (
        set OTS_TARGET=off
rem )
rem --------------------------------------------------------------------------
rem [JMS]
rem IF EXIST "%INST_DIR%\jms\lib\fjmsprovider.jar" (
rem     set JMS_TARGET=on
rem ) ELSE (
        set JMS_TARGET=off
rem )
rem --------------------------------------------------------------------------
rem [J2EE]
rem IF EXIST "%INST_DIR%\J2EE\lib\isj2ee.jar" (
rem     set J2EE_TARGET=on
rem ) ELSE (
        set J2EE_TARGET=off
rem )
rem --------------------------------------------------------------------------
rem [IJServer]
rem IF EXIST "%INST_DIR%\F3FMjs4\server\lib\catalina.jar" (
rem     IF "%J2EE_TARGET%" == "on" (
rem         set IJSERVER_TARGET=on
rem     ) ELSE (
rem         set IJSERVER_TARGET=off
rem     )
rem ) ELSE (
        set IJSERVER_TARGET=off
rem )
rem --------------------------------------------------------------------------
rem [ISCM]
rem IF EXIST "%INST_DIR%\etc\repository\repository.system" (
rem     set ISCM_TARGET=on
rem ) ELSE (
        set ISCM_TARGET=off
rem )
rem --------------------------------------------------------------------------
rem [ISJEE]
IF EXIST "%INST_DIR%\F3FMisjee\bin\ijbackup.bat" (
    set ISJEE_TARGET=on
) ELSE (
    set ISJEE_TARGET=off
)
rem --------------------------------------------------------------------------

rem ==========================================================================
:MAIN_RTN
rem ==========================================================================
isprintvl | FIND "Web" >NUL 2>&1
IF ERRORLEVEL 1 (
    set WEBJ_EDITION=off
) ELSE (
    set WEBJ_EDITION=on
)
DEL /F /Q %SVCTRACEFILE% > NUL 2>&1
ver | find "Windows NT" > NUL && goto WINNT
set XCOPY_FLAG=/Y
goto PROCEDURE_PART

:WINNT
set XCOPY_FLAG=

rem ==========================================================================
:PROCEDURE_PART
rem ==========================================================================
IF "%1" == "pre" (
    goto PRE_PART
)
IF "%1" == "post" (
    goto POST_PART
)
    goto ERROR_QUIT

rem ==========================================================================
:PRE_PART
rem ==========================================================================
rem RD /S /Q %TARGET_PATH% > NUL 2>&1
rem IF NOT EXIST %COMMON_PATH% (
rem     MD "%COMMON_PATH%"
rem     IF ERRORLEVEL 1 (
rem         ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31354:Making the directory was failed^(path=%COMMON_PATH%^)>%INST_DIR%\var\isrcexportimg.log
rem         ECHO IS: ERROR: is31354:Making the directory was failed^(path=%COMMON_PATH%^)
rem         goto ERROR_RTN
rem     )
rem )
rem IF NOT EXIST %TARGET_PATH% (
rem     MD "%TARGET_PATH%"
rem     IF ERRORLEVEL 1 (
rem         ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31354:Making the directory was failed^(path=%TARGET_PATH%^)>%INST_DIR%\var\isrcexportimg.log
rem         ECHO IS: ERROR: is31354:Making the directory was failed^(path=%TARGET_PATH%^)
rem         goto ERROR_RTN
rem     )
rem )
rem IF NOT EXIST %LOG_PATH% (
rem     MD "%LOG_PATH%"
rem     IF ERRORLEVEL 1 (
rem         ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31354:Making the directory was failed^(path=%LOG_PATH%^)>%INST_DIR%\var\isrcexportimg.log
rem         ECHO IS: ERROR: is31354:Making the directory was failed^(path=%LOG_PATH%^)
rem         goto ERROR_RTN
rem     )
rem )
IF NOT EXIST %INST_DIR%\var\rc (
    MD "%INST_DIR%\var\rc"
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31801: Making the directory was failed^(path=%INST_DIR%\var\rc^)>>%LOGFILE%
        ECHO IS: ERROR: is31801: Making the directory was failed^(path=%INST_DIR%\var\rc^)
        goto ERROR_RTN
    )
    set DEL_VAR_RC=yes
)

ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31805: %THIS_CMD_NAME% has been started>>%LOGFILE%

ECHO [%DATE:~-10% %TIME:~0,8%]>%INFOFILE%
ECHO ----------------------------------------------------------------------------- >>%INFOFILE%
ECHO %0 %1>>%INFOFILE%
ECHO:>>%INFOFILE%
ECHO INST_DIR          = %INST_DIR%>>%INFOFILE%
ECHO COMMON_PATH       = %COMMON_PATH%>>%INFOFILE%
ECHO TARGET_PATH       = %TARGET_PATH%>>%INFOFILE%
ECHO LOCKFILE          = %LOCKFILE%>>%INFOFILE%
ECHO LOG_PATH          = %LOG_PATH%>>%INFOFILE%
ECHO LOGFILE           = %LOGFILE%>>%INFOFILE%
ECHO INFOFILE          = %INFOFILE%>>%INFOFILE%
ECHO SVCTRACEFILE      = %SVCTRACEFILE%>>%INFOFILE%
rem ECHO RCX_SVRGRP_NAME   = %RCX_SVRGRP_NAME%>>%INFOFILE%
rem ECHO RCX_TGTSVR_NAME   = %RCX_TGTSVR_NAME%>>%INFOFILE%
rem ECHO RCX_TGTSVR_ADM_IP = %RCX_TGTSVR_ADM_IP%>>%INFOFILE%
rem ECHO RCX_TGTSVR_EXT_IP = %RCX_TGTSVR_EXT_IP%>>%INFOFILE%
ECHO ISCOM_TARGET      = %ISCOM_TARGET%>>%INFOFILE%
ECHO GUI_TARGET        = %GUI_TARGET%>>%INFOFILE%
ECHO JMX_TARGET        = %JMX_TARGET%>>%INFOFILE%
ECHO OD_TARGET         = %OD_TARGET%>>%INFOFILE%
ECHO ES_TARGET         = %ES_TARGET%>>%INFOFILE%
ECHO TD_TARGET         = %TD_TARGET%>>%INFOFILE%
ECHO OTS_TARGET        = %OTS_TARGET%>>%INFOFILE%
ECHO JMS_TARGET        = %JMS_TARGET%>>%INFOFILE%
ECHO J2EE_TARGET       = %J2EE_TARGET%>>%INFOFILE%
ECHO IJSERVER_TARGET   = %IJSERVER_TARGET%>>%INFOFILE%
ECHO ISCM_TARGET       = %ISCM_TARGET%>>%INFOFILE%
ECHO ISJEE_TARGET      = %ISJEE_TARGET%>>%INFOFILE%

DEL /F /Q "%COMMON_PATH%\services.tmp.swcm" > NUL 2>&1
ECHO Interstage Operation Tool>>%COMMON_PATH%\services.tmp.swcm
ECHO FJapache>>%COMMON_PATH%\services.tmp.swcm
ECHO Fujitsu Enabler>>%COMMON_PATH%\services.tmp.swcm
ECHO Interstage data store>>%COMMON_PATH%\services.tmp.swcm
ECHO INTERSTAGE API>>%COMMON_PATH%\services.tmp.swcm
ECHO INTERSTAGE>>%COMMON_PATH%\services.tmp.swcm
ECHO Interstage Java EE DAS>>%COMMON_PATH%\services.tmp.swcm
ECHO Interstage Java EE Node Agent>>%COMMON_PATH%\services.tmp.swcm
ECHO Interstage JServlet^(OperationManagement^)>>%COMMON_PATH%\services.tmp.swcm
ECHO Interstage Operation Tool^(FJapache^)>>%COMMON_PATH%\services.tmp.swcm
ECHO Interstage Server Monitor Service>>%COMMON_PATH%\services.tmp.swcm
ECHO Interstage Server Monitor Service^(Cache Manager^)>>%COMMON_PATH%\services.tmp.swcm
ECHO FUJITSU ND ׌vG[WFg>>%COMMON_PATH%\services.tmp.swcm
ECHO FUJITSU ND Load Measure Agent>>%COMMON_PATH%\services.tmp.swcm
ECHO CORBA/SOAP ClientGW>>%COMMON_PATH%\services.tmp.swcm
ECHO EventService>>%COMMON_PATH%\services.tmp.swcm
ECHO EventFactory>>%COMMON_PATH%\services.tmp.swcm
ECHO InterfaceRep_Cache Service>>%COMMON_PATH%\services.tmp.swcm
ECHO InterfaceRep_Cache_e Service>>%COMMON_PATH%\services.tmp.swcm
ECHO Message Queue 4.1 Broker>>%COMMON_PATH%\services.tmp.swcm
ECHO Interstage Message Queue Broker>>%COMMON_PATH%\services.tmp.swcm
ECHO Naming Service>>%COMMON_PATH%\services.tmp.swcm
ECHO NS LoadBalancingOption>>%COMMON_PATH%\services.tmp.swcm
ECHO ObjectTransactionService>>%COMMON_PATH%\services.tmp.swcm
ECHO OD_start>>%COMMON_PATH%\services.tmp.swcm
ECHO TransactionDirector>>%COMMON_PATH%\services.tmp.swcm

    cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" Register -F:"%COMMON_PATH%\services.tmp.swcm" -G:INTS_APSR -C:INTS_APSR >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs Register^) was failed^)>>%LOGFILE%
        ECHO IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs Register^) was failed^)
        goto ERROR_RTN
    )
    DEL /F /Q "%COMMON_PATH%\services.tmp.swcm" > NUL 2>&1


    "%INST_DIR%\bin\isrccrtservicelist" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 9 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31811: A system error occurred^(The command ^(isrccrtservicelist^) was failed^)>>%LOGFILE%
        ECHO IS: ERROR: is31811: A system error occurred^(The error occurred to the command ^(isrccrtservicelist^) was failed^)
        goto ERROR_RTN
    )
    IF ERRORLEVEL 3 (
        cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" Unregister -G:INTS_APSR2 >>%LOGFILE% 2>&1
        IF ERRORLEVEL 1 (
            ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs Unregister^) was failed^)>>%LOGFILE%
            ECHO IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs Unregister^) was failed^)
            goto ERROR_RTN
        )
        MOVE /Y "%INST_DIR%\var\rc\services2.tmp" "%COMMON_PATH%\services2.tmp.swcm" > NUL 2>&1
        cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" Register -F:"%COMMON_PATH%\services2.tmp.swcm" -G:INTS_APSR2 -C:INTS_APSR >>%LOGFILE% 2>&1
        IF ERRORLEVEL 1 (
            ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs Register^) was failed^)>>%LOGFILE%
            ECHO IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs Register^) was failed^)
            goto ERROR_RTN
        )
        goto NEXT
    )
    IF ERRORLEVEL 2 (
        MOVE /Y "%INST_DIR%\var\rc\services2.tmp" "%COMMON_PATH%\services2.tmp.swcm" > NUL 2>&1
        cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" Register -F:"%COMMON_PATH%\services2.tmp.swcm" -G:INTS_APSR2 -C:INTS_APSR >>%LOGFILE% 2>&1
        IF ERRORLEVEL 1 (
            ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs Register^) was failed^)>>%LOGFILE%
            ECHO IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs Register^) was failed^)
            goto ERROR_RTN
        )
        goto NEXT
    )
    IF ERRORLEVEL 1 (
        cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" Unregister -G:INTS_APSR2 >>%LOGFILE% 2>&1
        IF ERRORLEVEL 1 (
            ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs Unregister^) was failed^)>>%LOGFILE%
            ECHO IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs Unregister^) was failed^)
            goto ERROR_RTN
        )
        goto NEXT
    )
:NEXT

rem Interstage Stop
    cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" SuppressStartup -C:INTS_APSR >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs SuppressStartup^) was failed^)>>%LOGFILE%
        ECHO IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs SuppressStartup^) was failed^)
        goto ERROR_RTN
    )
    "%INST_DIR%\bin\isstop" -f >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        FINDSTR /V /R /C:"is318[0-9][0-9]:" %LOGFILE% | FINDSTR /R /C:"is[23][0-9][0-9][0-9][0-9]" | FINDSTR "ERROR: G[:"
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31811: A system error occurred^(The command ^(isstop -f^) was failed^)>>%LOGFILE%
        ECHO IS: ERROR: is31811: A system error occurred^(The command ^(isstop -f^) was failed^)
        goto ERROR_RTN
    )
    cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" StopServices -C:INTS_APSR -W:30 >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs StopServices^) was failed^)>>%LOGFILE%
        ECHO IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs StopServices^) was failed^)
        goto ERROR_RTN
    )

rem get localHost
rem call "%INST_DIR%\bin\isrcgetlocalhostname.bat" > %LOG_PATH%\localHost.def
rem IF ERRORLEVEL 1 (
rem     ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31388: The error occurred to the command ^(isrcgetlocalhostname^)>>%LOGFILE%
rem     goto ERROR_RTN
rem )
rem FOR /F %%I IN (%LOG_PATH%\localHost.def) DO (
rem     set localHost=%%I
rem )
rem DEL /F /Q "%LOG_PATH%\localHost.def" > NUL 2>&1

RD /S /Q %TARGET_PATH% > NUL 2>&1
IF NOT EXIST %TARGET_PATH% (
    MD "%TARGET_PATH%"
    IF ERRORLEVEL 1 (
        ECHO IS: ERROR: is31801: Making the directory was failed^(path=%TARGET_PATH%^)
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31801: Making the directory was failed^(path=%TARGET_PATH%^)
        goto ERROR_RTN
    )
)

rem ISCOM START
IF /I %ISCOM_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31808: [ISCOM] is started>>%LOGFILE%

    ECHO %INST_DIR%\bin\iscbackupsys.exe %TARGET_PATH%>>%LOGFILE%
    "%INST_DIR%\bin\iscbackupsys.exe" "%TARGET_PATH%" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        FINDSTR /V /R /C:"is318[0-9][0-9]:" %LOGFILE% | FINDSTR /R /C:"is[23][0-9][0-9][0-9][0-9]" | FINDSTR "ERROR: G[:"
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31810: [ISCOM] was failed>>%LOGFILE%
        ECHO IS: ERROR: is31810: [ISCOM] was failed
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31809: [ISCOM] was successful>>%LOGFILE%
    )
    ECHO:>%TARGET_PATH%\ISCOM.txt
)
rem ISCOM END

rem GUI START
IF /I %GUI_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[GUI] is started>>%LOGFILE%

    ECHO %INST_DIR%\gui\bin\isguibackup.bat %INST_DIR% %TARGET_PATH%\isgui>>%LOGFILE%
    call "%INST_DIR%\gui\bin\isguibackup.bat" "%INST_DIR%" "%TARGET_PATH%\isgui" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[GUI] was failed>>%LOGFILE%
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[GUI] was successful>>%LOGFILE%
    )
    ECHO:>%TARGET_PATH%\GUI.txt
)
rem GUI END

rem JMX START
IF /I %JMX_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[JMX] is started>>%LOGFILE%

    ECHO %INST_DIR%\bin\isjmxbackup.bat %INST_DIR% %TARGET_PATH%\isjmx>>%LOGFILE%
    call "%INST_DIR%\bin\isjmxbackup.bat" "%INST_DIR%" "%TARGET_PATH%\isjmx" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[JMX] was failed>>%LOGFILE%
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[JMX] was successful>>%LOGFILE%
    )
    ECHO:>%TARGET_PATH%\JMX.txt
)
rem JMX END

rem OD START
IF /I %OD_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31808: [OD] is started>>%LOGFILE%

  IF %WEBJ_EDITION%  ==  off  (
rem "%INST_DIR%\ODWIN\bin\odsetconfigex.exe" -a IIOP_hostname %localHost% >%LOG_PATH%\output.log 2>&1
rem IF ERRORLEVEL 1 (
rem     ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31388:The error occurred to the command ^(odsetconfigex^)>>%LOGFILE%
rem     goto ERROR_RTN
rem )
rem DEL /F /Q "%LOG_PATH%\output.log" > NUL 2>&1
    ECHO %INST_DIR%\ODWIN\bin\odbackupsys.exe %TARGET_PATH%>>%LOGFILE%
    "%INST_DIR%\ODWIN\bin\odbackupsys.exe" "%TARGET_PATH%" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        FINDSTR /V /R /C:"is318[0-9][0-9]:" %LOGFILE% | FINDSTR /R "^OD:.*od[0-9][0-9][0-9][0-9][0-9]" | FINDSTR "ERROR: G[:"
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31810: [OD] was failed>>%LOGFILE%
        ECHO IS: ERROR: is31810: [OD] was failed
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31809: [OD] was successful>>%LOGFILE%
    )
rem "%INST_DIR%\ODWIN\bin\odsetconfigex.exe" -d IIOP_hostname >%LOG_PATH%\output.log 2>&1
rem IF ERRORLEVEL 1 (
rem     ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31388:The error occurred to the command ^(odsetconfigex^)>>%LOGFILE%
rem     goto ERROR_RTN
rem )
rem DEL /F /Q "%LOG_PATH%\output.log" > NUL 2>&1
    ECHO:>%TARGET_PATH%\OD.txt
  ) ELSE (
    MD "%TARGET_PATH%\ODWIN"
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31801: Making the directory was failed^(path=%TARGET_PATH%\ODWIN^)>>%LOGFILE%
        ECHO IS: ERROR: is31801: Making the directory was failed^(path=%TARGET_PATH%\ODWIN^)
        goto ERROR_RTN
    )

    ECHO COPY %XCOPY_FLAG% %INST_DIR%\ODWIN\etc\config %TARGET_PATH%\ODWIN\>>%LOGFILE%
    COPY %XCOPY_FLAG% "%INST_DIR%\ODWIN\etc\config" "%TARGET_PATH%\ODWIN\" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31810: [OD] was failed>>%LOGFILE%
        ECHO IS: ERROR: is31810: [OD] was failed
        goto ERROR_RTN
    )

    ECHO COPY %XCOPY_FLAG% %INST_DIR%\ODWIN\etc\inithost %TARGET_PATH%\ODWIN\>>%LOGFILE%
    COPY %XCOPY_FLAG% "%INST_DIR%\ODWIN\etc\inithost" "%TARGET_PATH%\ODWIN\" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31810: [OD] was failed>>%LOGFILE%
        ECHO IS: ERROR: is31810: [OD] was failed
        goto ERROR_RTN
    )

    IF EXIST "%INST_DIR%\ODWIN\etc\ssl.env" (
        ECHO COPY %XCOPY_FLAG% %INST_DIR%\ODWIN\etc\ssl.env %TARGET_PATH%\ODWIN\>>%LOGFILE%
        COPY %XCOPY_FLAG% "%INST_DIR%\ODWIN\etc\ssl.env" "%TARGET_PATH%\ODWIN\" >>%LOGFILE% 2>&1
        IF ERRORLEVEL 1 (
            ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31810: [OD] was failed>>%LOGFILE%
            ECHO IS: ERROR: is31810: [OD] was failed
            goto ERROR_RTN
        )
    )
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31809: [OD] was successful>>%LOGFILE%
    ECHO:>%TARGET_PATH%\OD.txt
  )
)
rem OD END

rem ES START
IF /I %ES_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[ES] is started>>%LOGFILE%

    ECHO %INST_DIR%\bin\esbackupsys.exe -d %TARGET_PATH%>>%LOGFILE%
    "%INST_DIR%\bin\esbackupsys.exe" -d "%TARGET_PATH%" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 0 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[ES] was successful>>%LOGFILE%
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[ES] was failed>>%LOGFILE%
        goto ERROR_RTN
    )
    ECHO:>%TARGET_PATH%\ES.txt
)
rem ES END

rem TD START
IF /I %TD_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[TD] is started>>%LOGFILE%

    ECHO %INST_DIR%\bin\tdbackupsys.exe %TARGET_PATH%>>%LOGFILE%
    "%INST_DIR%\bin\tdbackupsys.exe" "%TARGET_PATH%" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[TD] was failed>>%LOGFILE%
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[TD] was successful>>%LOGFILE%
    )
    ECHO:>%TARGET_PATH%\TD.txt
)
rem TD END

rem OTS START
IF /I %OTS_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[OTS] is started>>%LOGFILE%

    ECHO %INST_DIR%\bin\otsbackupsys.exe %TARGET_PATH%>>%LOGFILE%
    "%INST_DIR%\bin\otsbackupsys.exe" "%TARGET_PATH%" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[OTS] was failed>>%LOGFILE%
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[OTS] was successful>>%LOGFILE%
    )
    ECHO:>%TARGET_PATH%\OTS.txt
)
rem OTS END

rem JMS START
IF /I %JMS_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[JMS] is started>>%LOGFILE%

    ECHO %INST_DIR%\bin\jmsbackup.exe -d %TARGET_PATH%>>%LOGFILE%
    "%INST_DIR%\bin\jmsbackup.exe" -d "%TARGET_PATH%" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[JMS] was failed>>%LOGFILE%
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[JMS] was successful>>%LOGFILE%
    )
    ECHO:>%TARGET_PATH%\JMS.txt
)
rem JMS END

rem J2EE START
IF /I %J2EE_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[J2EE] is started>>%LOGFILE%

    ECHO %INST_DIR%\bin\j2eebackup.exe -d %TARGET_PATH%>>%LOGFILE%
    "%INST_DIR%\bin\j2eebackup.exe" -d "%TARGET_PATH%" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[J2EE] was failed>>%LOGFILE%
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[J2EE] was successful>>%LOGFILE%
    )
    ECHO:>%TARGET_PATH%\J2EE.txt
)
rem J2EE END

rem IJServer START
IF /I %IJSERVER_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[IJServer] is started>>%LOGFILE%

    ECHO %INST_DIR%\bin\ijsbackup.exe -d %TARGET_PATH%>>%LOGFILE%
    "%INST_DIR%\bin\ijsbackup.exe" -d "%TARGET_PATH%" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[IJServer] was failed>>%LOGFILE%
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[IJServer] was successful>>%LOGFILE%
    )
    ECHO:>%TARGET_PATH%\IJSERVER.txt
)
rem IJServer END

rem ISCM START
IF /I %ISCM_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[ISCM] is started>>%LOGFILE%

    MD "%TARGET_PATH%\jmx_cm"
    ECHO %INST_DIR%\bin\isrepbackup %TARGET_PATH%\jmx_cm>>%LOGFILE%
    call "%INST_DIR%\bin\isrepbackup" "%TARGET_PATH%\jmx_cm" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[ISCM] was failed>>%LOGFILE%
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[ISCM] was successful>>%LOGFILE%
    )
    ECHO:>%TARGET_PATH%\ISCM.txt
)
rem ISCM END

rem ISJEE START
IF /I %ISJEE_TARGET% ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31808: [ISJEE] is started>>%LOGFILE%

    ECHO %INST_DIR%\F3FMisjee\bin\ijbackup.bat -d %TARGET_PATH%>>%LOGFILE%
    call "%INST_DIR%\F3FMisjee\bin\ijbackup.bat" -d "%TARGET_PATH%" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        FINDSTR /V /R /C:"is318[0-9][0-9]:" %LOGFILE% | FINDSTR /R /C:"ISJEE_OM40[0-9][0-9]" | FINDSTR /V /R /C:"ISJEE_OM400[25]" | FINDSTR "ERROR: G[:"
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31810: [ISJEE] was failed>>%LOGFILE%
        ECHO IS: ERROR: is31810: [ISJEE] was failed
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31809: [ISJEE] was successful>>%LOGFILE%
    )
    ECHO:>%TARGET_PATH%\ISJEE.txt
)
rem ISJEE END

rem ==========================================================================
rem Exit
rem ==========================================================================
:EXIT_RTN
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31806: %THIS_CMD_NAME% has been finished normally>>%LOGFILE%
    IF "%DEL_VAR_RC%" == "yes" (
        RD "%INST_DIR%\var\rc" > NUL 2>&1
    )
    set RET_VAL=0
    EXIT /B %RET_VAL%
    ENDLOCAL

rem ==========================================================================
rem Error
rem ==========================================================================
:ERROR_RTN
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31807: An error has occurred while processing %THIS_CMD_NAME%>>%LOGFILE%
    IF "%DEL_VAR_RC%" == "yes" (
        RD "%INST_DIR%\va\rc" > NUL 2>&1
    )
    RD %INST_DIR%\var\rc > NUL 2>&1
    set RET_VAL=1
    EXIT /B %RET_VAL%
    ENDLOCAL

rem ==========================================================================
:POST_PART
rem ==========================================================================
IF NOT EXIST %COMMON_PATH% (
    MD "%COMMON_PATH%"
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31354:Making the directory was failed^(path=%COMMON_PATH%^)>%INST_DIR%\var\isrcexportimg.log
        goto ERROR_POST
    )
)
IF NOT EXIST %LOG_PATH% (
    MD "%LOG_PATH%"
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31354:Making the directory was failed^(path=%LOG_PATH%^)>%INST_DIR%\var\isrcexportimg.log
        goto ERROR_POST
    )
)

ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31385:isrcexportimg(%1) is started>>%LOGFILE%

rem Get serverGroupName
call "%INST_DIR%\bin\isrcprintconf.bat" -t serverGroupName > %LOG_PATH%\svgname.def
IF ERRORLEVEL 1 (
    IF EXIST "%LOGFILE%" (
        COPY "%LOGFILE%" + "%LOG_PATH%\svgname.def" "%LOGFILE%" /B > NUL 2>&1
    ) ELSE (
        COPY "%LOG_PATH%\svgname.def" "%LOGFILE%" > NUL 2>&1
    )
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31396:An error is in the registered servergroupname>>%LOGFILE%
    goto ERROR_POST
)
FOR %%I IN (%LOG_PATH%\svgname.def) DO (
    IF "%%~zI" == "0" (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31396:An error is in the registered servergroupname>>%LOGFILE%
        goto ERROR_POST
    )
)
FOR /F %%I IN (%LOG_PATH%\svgname.def) DO (
    set svgname=%%I
)
IF NOT "%RCX_SVRGRP_NAME%" == "%svgname%" (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31396:An error is in the registered servergroupname>>%LOGFILE%
    goto ERROR_POST
)
DEL /F /Q "%LOG_PATH%\svgname.def" > NUL 2>&1

rem Get network
call "%INST_DIR%\bin\isrcprintconf.bat" %RCX_SVRGRP_NAME% businessIpAddress network >%LOG_PATH%\network.def
IF ERRORLEVEL 1 (
    IF EXIST "%LOGFILE%" (
        COPY "%LOGFILE%" + "%LOG_PATH%\network.def" "%LOGFILE%" /B > NUL 2>&1
    ) ELSE (
        COPY "%LOG_PATH%\network.def" "%LOGFILE%" > NUL 2>&1
    )
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31364:rc.properties contains invalid data.^(%RCX_SVRGRP_NAME%.businessIpAddress.network^)>>%LOGFILE%
    goto ERROR_POST
)
FOR %%I IN (%LOG_PATH%\network.def) DO (
    IF "%%~zI" == "0" (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31364:rc.properties contains invalid data.^(%RCX_SVRGRP_NAME%.businessIpAddress.network^)>>%LOGFILE%
        goto ERROR_POST
    )
)
FOR /F %%I IN (%LOG_PATH%\network.def) DO (
    set network=%%I
)

rem Get subnetmask
call "%INST_DIR%\bin\isrcprintconf.bat" %RCX_SVRGRP_NAME% businessIpAddress subnetmask >%LOG_PATH%\subnet.def
IF ERRORLEVEL 1 (
    IF EXIST "%LOGFILE%" (
        COPY "%LOGFILE%" + "%LOG_PATH%\subnet.def" "%LOGFILE%" /B > NUL 2>&1
    ) ELSE (
        COPY "%LOG_PATH%\subnet.def" "%LOGFILE%" > NUL 2>&1
    )
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31364:rc.properties contains invalid data.^(%RCX_SVRGRP_NAME%.businessIpAddress.subnetmask^)>>%LOGFILE%
    goto ERROR_POST
)
FOR %%I IN (%LOG_PATH%\subnet.def) DO (
    IF "%%~zI" == "0" (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31364:rc.properties contains invalid data.^(%RCX_SVRGRP_NAME%.businessIpAddress.subnetmask^)>>%LOGFILE%
        goto ERROR_POST
    )
)
FOR /F %%I IN (%LOG_PATH%\subnet.def) DO (
    set subnet=%%I
)

rem Get localhostname
rem call "%INST_DIR%\bin\isrcprintconf.bat" %RCX_SVRGRP_NAME% localHost >%LOG_PATH%\localHost.def
rem IF ERRORLEVEL 1 (
rem     IF EXIST "%LOGFILE%" (
rem         COPY "%LOGFILE%" + "%LOG_PATH%\localHost.def" "%LOGFILE%" /B > NUL 2>&1
rem     ) ELSE (
rem         COPY "%LOG_PATH%\localHost.def" "%LOGFILE%" > NUL 2>&1
rem     )
rem     ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31364:rc.properties contains invalid data.^(%RCX_SVRGRP_NAME%.localHost^)>>%LOGFILE%
rem     goto ERROR_POST
rem )
rem FOR %%I IN (%LOG_PATH%\localHost.def) DO (
rem     IF "%%~zI" == "0" (
rem         ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31364:rc.properties contains invalid data.^(%RCX_SVRGRP_NAME%.localHost^)>>%LOGFILE%
rem         goto ERROR_POST
rem     )
rem )
rem FOR /F %%I IN (%LOG_PATH%\localHost.def) DO (
rem     set localHost=%%I
rem )

rem Get virtualhostname
set vtlhost_exist=1
call "%INST_DIR%\bin\isrcprintconf.bat" %RCX_SVRGRP_NAME% trdVirtualHost >%LOG_PATH%\virtualHost.def
IF ERRORLEVEL 1 (
    set vtlhost_exist=0
) ELSE (
    FOR %%I IN (%LOG_PATH%\virtualHost.def) DO (
        IF "%%~zI" == "0" (
            set vtlhost_exist=0
        )
    )
    FOR /F %%I IN (%LOG_PATH%\virtualHost.def) DO (
        set virtualHost=%%I
    )
)

rem Get RCX_TGTSVR_EXT_IP
ECHO %RCX_TGTSVR_EXT_IP%> %LOG_PATH%\ipaddr.def

FOR /F %%I IN (%LOG_PATH%\ipaddr.def) DO (
    "%INST_DIR%\bin\isrcconvbusinessip.exe" "%%I" > %LOG_PATH%\ipaddr2.def
)

FOR /F %%I IN (%LOG_PATH%\ipaddr2.def) DO (
    "%INST_DIR%\bin\isrcdiffnet.exe" %%I %network% %subnet%
    IF NOT ERRORLEVEL 1 (
        set addr=%%I
        "%INST_DIR%\bin\isrcconvlocalhostname.exe" %%I > %LOG_PATH%\localHost.def
        FOR %%I IN (%LOG_PATH%\localHost.def) DO (
            IF "%%~zI" == "0" (
                ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31364:rc.properties contains invalid data.^(%RCX_SVRGRP_NAME%.localHost^)>>%LOGFILE%
                goto ERROR_POST
            )
        )
        FOR /F %%I IN (%LOG_PATH%\localHost.def) DO (
            set localHost=%%I
        )
        goto FOR_END
    )
)
ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31394:Acquisition of IP address went wrong>>%LOGFILE%
goto ERROR_POST

:FOR_END
    "%INST_DIR%\bin\isrcaddhost.exe" "%WINDIR%\system32\drivers\etc\hosts" %localHost% %addr% > %LOG_PATH%\output.log 2>&1
    set status_rc=%ERRORLEVEL%
    IF NOT "%status_rc%" == "0" (
        IF EXIST "%LOGFILE%" (
            COPY "%LOGFILE%" + "%LOG_PATH%\output.log" "%LOGFILE%" /B > NUL 2>&1
        ) ELSE (
            COPY "%LOG_PATH%\output.log" "%LOGFILE%" > NUL 2>&1
        )
        DEL /F /Q "%LOG_PATH%\output.log" > NUL 2>&1
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31393:A setup to hosts cannot be performed ^(code=%status_rc%^)>>%LOGFILE%
        goto ERROR_POST
    )
    IF "%vtlhost_exist%" == "1" (
        "%INST_DIR%\bin\isrcaddhost.exe" "%WINDIR%\system32\drivers\etc\hosts" %virtualHost% %addr% > %LOG_PATH%\output.log 2>&1
        set status_rc=%ERRORLEVEL%
        IF NOT "%status_rc%" == "0" (
            IF EXIST "%LOGFILE%" (
                COPY "%LOGFILE%" + "%LOG_PATH%\output.log" "%LOGFILE%" /B > NUL 2>&1
            ) ELSE (
                COPY "%LOG_PATH%\output.log" "%LOGFILE%" > NUL 2>&1
            )
            DEL /F /Q "%LOG_PATH%\output.log" > NUL 2>&1
            ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31393:A setup to hosts cannot be performed ^(code=%status_rc%^)>>%LOGFILE%
            goto ERROR_POST
        )
    )
    DEL /F /Q "%LOG_PATH%\output.log" > NUL 2>&1

ECHO network    = %network%>>%INFOFILE%
ECHO subnetmask = %subnet%>>%INFOFILE%
ECHO localHost  = %localHost%>>%INFOFILE%
IF "%vtlhost_exist%" == "1" (
ECHO trdVirtualHost = %virtualHost%>>%INFOFILE%
)

DEL /F /Q "%LOG_PATH%\network.def" > NUL 2>&1
DEL /F /Q "%LOG_PATH%\subnet.def" > NUL 2>&1
DEL /F /Q "%LOG_PATH%\localHost.def" > NUL 2>&1
DEL /F /Q "%LOG_PATH%\virtualHost.def" > NUL 2>&1
DEL /F /Q "%LOG_PATH%\ipaddr.def" > NUL 2>&1
DEL /F /Q "%LOG_PATH%\ipaddr2.def" > NUL 2>&1
DEL /F /Q "%LOG_PATH%\output.log" > NUL 2>&1

    DEL /F /Q "%LOG_PATH%\output.log" > NUL 2>&1

    NET START "Interstage Operation Tool" > NUL 2>&1

rem Interstage Start
    "%INST_DIR%\bin\isstart" 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31388:The error occurred to the command ^(isstart^)>>%LOGFILE%
        goto ERROR_POST
    )
    cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" RestoreStartup -C:INTS_APSR >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31388:The error occurred to the command ^(isrcPrepService.vbs RestoreStartup^)>>%LOGFILE%
        goto ERROR_POST
    )
    cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" StartServices -C:INTS_APSR >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31388:The error occurred to the command ^(isrcPrepService.vbs StartServices^)>>%LOGFILE%
        goto ERROR_POST
    )

    IF EXIST "%INST_DIR%\var\rc\services2.tmp" (
        cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" Unregister -G:INTS_APSR2 >>%LOGFILE% 2>&1
        IF ERRORLEVEL 1 (
            ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31388:The error occurred to the command ^(isrcPrepService.vbs Unregister^)>>%LOGFILE%
            goto ERROR_POST
        )
        DEL /F /Q "%INST_DIR%\var\rc\services2.tmp" > NUL 2>&1
    )

:EXIT_POST
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31386:isrcexportimg(%1) was ended normally>>%LOGFILE%
    set RET_VAL=0
    EXIT %RET_VAL%
    ENDLOCAL

:ERROR_POST
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31387:isrcexportimg(%1) was ended failure>>%LOGFILE%
    set RET_VAL=1
    EXIT %RET_VAL%
    ENDLOCAL

:ERROR_QUIT
    IF NOT EXIST %COMMON_PATH% (
        MD "%COMMON_PATH%"
    )
    IF NOT EXIST %LOG_PATH% (
        MD "%LOG_PATH%"
    )
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31395:Invalid parameter>>%LOGFILE%
    ECHO IS: ERROR: is31395:Invalid parameter
    set RET_VAL=1
    EXIT %RET_VAL%
    ENDLOCAL
