@ECHO OFF
SETLOCAL
rem ==========================================================================
rem
rem Copyright 2010 FUJITSU LIMITED
rem
rem ==========================================================================
rem <Function>
rem  isswcmimportimg.bat
rem
rem <Function Specification>
rem  To restore or import the resource at once, use this batch file.
rem
rem <Parameter>
rem  None
rem
rem <Return Value>
rem  0 : normal
rem  1 : abnormal
rem
rem <Notice>
rem
rem
rem ==========================================================================

set THIS_CMD_NAME=%~n0

rem ==========================================================================
:DEFINITION_PART
rem ==========================================================================
rem [Common]
rem set INST_DIR=%IS_HOME%
rem set COMMON_PATH=%IS_HOME%\var\rc
rem set TARGET_PATH=%COMMON_PATH%\backup
rem set LOG_PATH=%COMMON_PATH%\log
rem set LOGFILE=%LOG_PATH%\isrcimportimg.log
set INFOFILE=%LOG_PATH%\%MAIN_CMD_NAME%_env.log
rem set STATUSFILE=%COMMON_PATH%\isjmxrc.txt
set SCW_PREP_SERVICE_LOG=%LOG_PATH%\%MAIN_CMD_NAME%_svctrace.log
set SVCTRACEFILE=%SCW_PREP_SERVICE_LOG%
set KEYSTORE_PATH=%INST_DIR%\F3FMisjee\var\domains\interstage\config
rem --------------------------------------------------------------------------
rem [ISCOM]
    IF EXIST "%INST_DIR%\bin\iscbackupsys.exe" (
        IF EXIST "%TARGET_PATH%\ISCOM.txt" (
            set ISCOM_TARGET=on
        ) ELSE (
            set ISCOM_TARGET=off
        )
    ) ELSE (
        IF EXIST "%INST_DIR%\td\bin\iscbackupsys.exe" (
            IF EXIST "%TARGET_PATH%\ISCOM.txt" (
                set ISCOM_TARGET=on
            ) ELSE (
                set ISCOM_TARGET=off
            )
        ) ELSE (
            set ISCOM_TARGET=off
        )
    )
rem --------------------------------------------------------------------------
rem [GUI]
rem IF EXIST "%INST_DIR%\gui\etc\config" (
rem     IF EXIST "%TARGET_PATH%\GUI.txt" (
rem         set GUI_TARGET=on
rem     ) ELSE (
rem         set GUI_TARGET=off
rem     )
rem ) ELSE (
            set GUI_TARGET=off
rem )
rem --------------------------------------------------------------------------
rem [JMX]
rem IF EXIST "%INST_DIR%\lib\isjmxadmin.jar" (
rem     IF EXIST "%TARGET_PATH%\JMX.txt" (
rem         set JMX_TARGET=on
rem     ) ELSE (
rem         set JMX_TARGET=off
rem     )
rem ) ELSE (
            set JMX_TARGET=off
rem )
rem --------------------------------------------------------------------------
rem [OD]
    IF EXIST "%INST_DIR%\ODWIN\bin\odbackupsys.exe" (
        IF EXIST "%TARGET_PATH%\OD.txt" (
            set OD_TARGET=on
        ) ELSE (
            set OD_TARGET=off
        )
    ) ELSE (
            set OD_TARGET=off
    )
rem --------------------------------------------------------------------------
rem [ES]
rem IF EXIST "%INST_DIR%\bin\esdmnmain.exe" (
rem     IF EXIST "%TARGET_PATH%\ES.txt" (
rem         set ES_TARGET=on
rem     ) ELSE (
rem         set ES_TARGET=off
rem     )
rem ) ELSE (
rem     IF EXIST "%INST_DIR%\eswin\bin\esdmnmain.exe" (
rem         IF EXIST "%TARGET_PATH%\ES.txt" (
rem             set ES_TARGET=on
rem         ) ELSE (
rem             set ES_TARGET=off
rem         )
rem     ) ELSE (
            set ES_TARGET=off
rem     )
rem )
rem --------------------------------------------------------------------------
rem [TD]
rem IF EXIST "%INST_DIR%\bin\tdbackupsys.exe" (
rem     IF EXIST "%TARGET_PATH%\TD.txt" (
rem         set TD_TARGET=on
rem     ) ELSE (
rem         set TD_TARGET=off
rem     )
rem ) ELSE (
rem     IF EXIST "%INST_DIR%\td\bin\tdbackupsys.exe" (
rem         IF EXIST "%TARGET_PATH%\TD.txt" (
rem             set TD_TARGET=on
rem         ) ELSE (
rem             set TD_TARGET=off
rem         )
rem     ) ELSE (
            set TD_TARGET=off
rem     )
rem )
rem --------------------------------------------------------------------------
rem [OTS]
rem IF EXIST "%INST_DIR%\ots\etc\sysconfig" (
rem     IF EXIST "%TARGET_PATH%\OTS.txt" (
rem         set OTS_TARGET=on
rem     ) ELSE (
rem         set OTS_TARGET=off
rem     )
rem ) ELSE (
            set OTS_TARGET=off
rem )
rem --------------------------------------------------------------------------
rem [JMS]
rem IF EXIST "%INST_DIR%\jms\lib\fjmsprovider.jar" (
rem     IF EXIST "%TARGET_PATH%\JMS.txt" (
rem         set JMS_TARGET=on
rem     ) ELSE (
rem         set JMS_TARGET=off
rem     )
rem ) ELSE (
            set JMS_TARGET=off
rem )
rem --------------------------------------------------------------------------
rem [J2EE]
rem IF EXIST "%INST_DIR%\J2EE\lib\isj2ee.jar" (
rem     IF EXIST "%TARGET_PATH%\J2EE.txt" (
rem         set J2EE_TARGET=on
rem     ) ELSE (
rem         set J2EE_TARGET=off
rem     )
rem ) ELSE (
            set J2EE_TARGET=off
rem )
rem --------------------------------------------------------------------------
rem [IJServer]
rem IF EXIST "%INST_DIR%\F3FMjs4\server\lib\catalina.jar" (
rem     IF "%J2EE_TARGET%" == "on" (
rem         IF EXIST "%TARGET_PATH%\IJSERVER.txt" (
rem             set IJSERVER_TARGET=on
rem         ) ELSE (
rem             set IJSERVER_TARGET=off
rem         )
rem     ) ELSE (
rem         set IJSERVER_TARGET=off
rem     )
rem     ) ELSE (
            set IJSERVER_TARGET=off
rem    )
rem --------------------------------------------------------------------------
rem [ISCM]
rem IF EXIST "%INST_DIR%\etc\repository\repository.system" (
rem     IF EXIST "%TARGET_PATH%\ISCM.txt" (
rem         set ISCM_TARGET=on
rem     ) ELSE (
rem         set ISCM_TARGET=off
rem     )
rem ) ELSE (
            set ISCM_TARGET=off
rem )
rem --------------------------------------------------------------------------
rem [ISJEE]
IF EXIST "%INST_DIR%\F3FMisjee\bin\ijrestore.bat" (
    IF EXIST "%TARGET_PATH%\ISJEE.txt" (
        set ISJEE_TARGET=on
    ) ELSE (
        set ISJEE_TARGET=off
    )
) ELSE (
    set ISJEE_TARGET=off
)
rem --------------------------------------------------------------------------

rem ==========================================================================
:MAIN_RTN
rem ==========================================================================
isprintvl | FIND "Web" >NUL 2>&1
IF ERRORLEVEL 1 (
    set WEBJ_EDITION=off
) ELSE (
    set WEBJ_EDITION=on
)
DEL /F /Q %SVCTRACEFILE% > NUL 2>&1
ver | find "Windows NT" > NUL && goto WINNT
set XCOPY_FLAG=/Y
goto PROCEDURE_PART

:WINNT
set XCOPY_FLAG=

set localHost=%2

rem ==========================================================================
:PROCEDURE_PART
rem ==========================================================================
IF "%1" == "pre" (
    goto PRE_PART
)
IF "%1" == "post" (
    goto POST_PART
)
    goto ERROR_QUIT

rem ==========================================================================
:POST_PART
rem ==========================================================================
rem IF NOT EXIST %COMMON_PATH% (
rem     MD "%COMMON_PATH%"
rem     IF ERRORLEVEL 1 (
rem         ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31354:Making the directory was failed^(path=%COMMON_PATH%^)>%INST_DIR%\var\isrcimportimg.log
rem         goto ERROR_RTN
rem     )
rem )
rem IF NOT EXIST %LOG_PATH% (
rem     MD "%LOG_PATH%"
rem     IF ERRORLEVEL 1 (
rem         ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31354:Making the directory was failed^(path=%LOG_PATH%^)>%INST_DIR%\var\isrcimportimg.log
rem         goto ERROR_RTN
rem     )
rem )

ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31805: %THIS_CMD_NAME% has been started>>%LOGFILE%

ECHO [%DATE:~-10% %TIME:~0,8%]>%INFOFILE%
ECHO ----------------------------------------------------------------------------- >>%INFOFILE%
ECHO %0 %1 %localHost%>>%INFOFILE%
ECHO:>>%INFOFILE%
ECHO INST_DIR          = %INST_DIR%>>%INFOFILE%
ECHO COMMON_PATH       = %COMMON_PATH%>>%INFOFILE%
ECHO TARGET_PATH       = %TARGET_PATH%>>%INFOFILE%
ECHO LOCKFILE          = %LOCKFILE%>>%INFOFILE%
ECHO LOG_PATH          = %LOG_PATH%>>%INFOFILE%
ECHO LOGFILE           = %LOGFILE%>>%INFOFILE%
ECHO INFOFILE          = %INFOFILE%>>%INFOFILE%
ECHO SVCTRACEFILE      = %SVCTRACEFILE%>>%INFOFILE%
rem ECHO RCX_SVRGRP_NAME   = %RCX_SVRGRP_NAME%>>%INFOFILE%
rem ECHO RCX_TGTSVR_NAME   = %RCX_TGTSVR_NAME%>>%INFOFILE%
rem ECHO RCX_TGTSVR_ADM_IP = %RCX_TGTSVR_ADM_IP%>>%INFOFILE%
rem ECHO RCX_TGTSVR_EXT_IP = %RCX_TGTSVR_EXT_IP%>>%INFOFILE%
ECHO localHost         = %localHost%>>%INFOFILE%
ECHO ISCOM_TARGET      = %ISCOM_TARGET%>>%INFOFILE%
ECHO GUI_TARGET        = %GUI_TARGET%>>%INFOFILE%
ECHO JMX_TARGET        = %JMX_TARGET%>>%INFOFILE%
ECHO OD_TARGET         = %OD_TARGET%>>%INFOFILE%
ECHO ES_TARGET         = %ES_TARGET%>>%INFOFILE%
ECHO TD_TARGET         = %TD_TARGET%>>%INFOFILE%
ECHO OTS_TARGET        = %OTS_TARGET%>>%INFOFILE%
ECHO JMS_TARGET        = %JMS_TARGET%>>%INFOFILE%
ECHO J2EE_TARGET       = %J2EE_TARGET%>>%INFOFILE%
ECHO IJSERVER_TARGET   = %IJSERVER_TARGET%>>%INFOFILE%
ECHO ISCM_TARGET       = %ISCM_TARGET%>>%INFOFILE%
ECHO ISJEE_TARGET      = %ISJEE_TARGET%>>%INFOFILE%

rem Get serverGroupName
rem call "%INST_DIR%\bin\isrcprintconf.bat" -t serverGroupName > %LOG_PATH%\svgname.def
rem IF ERRORLEVEL 1 (
rem     IF EXIST "%LOGFILE%" (
rem         COPY "%LOGFILE%" + "%LOG_PATH%\svgname.def" "%LOGFILE%" /B > NUL 2>&1
rem     ) ELSE (
rem         COPY "%LOG_PATH%\svgname.def" "%LOGFILE%" > NUL 2>&1
rem     )
rem     ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31396:An error is in the registered servergroupname>>%LOGFILE%
rem     goto ERROR_RTN
rem )
rem FOR %%I IN (%LOG_PATH%\svgname.def) DO (
rem     IF "%%~zI" == "0" (
rem         ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31396:An error is in the registered servergroupname>>%LOGFILE%
rem         goto ERROR_RTN
rem     )
rem )
rem FOR /F %%I IN (%LOG_PATH%\svgname.def) DO (
rem     set svgname=%%I
rem )
rem IF NOT "%RCX_SVRGRP_NAME%" == "%svgname%" (
rem     ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31396:An error is in the registered servergroupname>>%LOGFILE%
rem     goto ERROR_RTN
rem )
rem DEL /F /Q "%LOG_PATH%\svgname.def" > NUL 2>&1

rem Get network
rem call "%INST_DIR%\bin\isrcprintconf.bat" %RCX_SVRGRP_NAME% businessIpAddress network >%LOG_PATH%\network.def
rem IF ERRORLEVEL 1 (
rem     IF EXIST "%LOGFILE%" (
rem         COPY "%LOGFILE%" + "%LOG_PATH%\network.def" "%LOGFILE%" /B > NUL 2>&1
rem     ) ELSE (
rem         COPY "%LOG_PATH%\network.def" "%LOGFILE%" > NUL 2>&1
rem     )
rem     ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31364:rc.properties contains invalid data.^(%RCX_SVRGRP_NAME%.businessIpAddress.network^)>>%LOGFILE%
rem     goto ERROR_RTN
rem )
rem FOR %%I IN (%LOG_PATH%\network.def) DO (
rem     IF "%%~zI" == "0" (
rem         ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31364:rc.properties contains invalid data.^(%RCX_SVRGRP_NAME%.businessIpAddress.network^)>>%LOGFILE%
rem         goto ERROR_RTN
rem     )
rem )
rem FOR /F %%I IN (%LOG_PATH%\network.def) DO (
rem     set network=%%I
rem )

rem Get subnetmask
rem call "%INST_DIR%\bin\isrcprintconf.bat" %RCX_SVRGRP_NAME% businessIpAddress subnetmask >%LOG_PATH%\subnet.def
rem IF ERRORLEVEL 1 (
rem     IF EXIST "%LOGFILE%" (
rem         COPY "%LOGFILE%" + "%LOG_PATH%\subnet.def" "%LOGFILE%" /B > NUL 2>&1
rem     ) ELSE (
rem         COPY "%LOG_PATH%\subnet.def" "%LOGFILE%" > NUL 2>&1
rem     )
rem     ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31364:rc.properties contains invalid data.^(%RCX_SVRGRP_NAME%.businessIpAddress.subnetmask^)>>%LOGFILE%
rem     goto ERROR_RTN
rem )
rem FOR %%I IN (%LOG_PATH%\subnet.def) DO (
rem     IF "%%~zI" == "0" (
rem         ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31364:rc.properties contains invalid data.^(%RCX_SVRGRP_NAME%.businessIpAddress.subnetmask^)>>%LOGFILE%
rem         goto ERROR_RTN
rem     )
rem )
rem FOR /F %%I IN (%LOG_PATH%\subnet.def) DO (
rem     set subnet=%%I
rem )

rem Get localhostname
rem call "%INST_DIR%\bin\isrcprintconf.bat" %RCX_SVRGRP_NAME% localHost >%LOG_PATH%\localHost.def
rem IF ERRORLEVEL 1 (
rem     IF EXIST "%LOGFILE%" (
rem         COPY "%LOGFILE%" + "%LOG_PATH%\localHost.def" "%LOGFILE%" /B > NUL 2>&1
rem     ) ELSE (
rem         COPY "%LOG_PATH%\localHost.def" "%LOGFILE%" > NUL 2>&1
rem     )
rem     ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31364:rc.properties contains invalid data.^(%RCX_SVRGRP_NAME%.localHost^)>>%LOGFILE%
rem     goto ERROR_RTN
rem )
rem FOR %%I IN (%LOG_PATH%\localHost.def) DO (
rem     IF "%%~zI" == "0" (
rem         ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31364:rc.properties contains invalid data.^(%RCX_SVRGRP_NAME%.localHost^)>>%LOGFILE%
rem         goto ERROR_RTN
rem     )
rem )
rem FOR /F %%I IN (%LOG_PATH%\localHost.def) DO (
rem     set localHost=%%I
rem )

rem Get virtualhostname
rem set vtlhost_exist=1
rem call "%INST_DIR%\bin\isrcprintconf.bat" %RCX_SVRGRP_NAME% trdVirtualHost >%LOG_PATH%\virtualHost.def
rem IF ERRORLEVEL 1 (
rem     set vtlhost_exist=0
rem ) ELSE (
rem     FOR %%I IN (%LOG_PATH%\virtualHost.def) DO (
rem         IF "%%~zI" == "0" (
rem             set vtlhost_exist=0
rem         )
rem     )
rem     FOR /F %%I IN (%LOG_PATH%\virtualHost.def) DO (
rem         set virtualHost=%%I
rem     )
rem )

rem Get RCX_TGTSVR_EXT_IP
rem ECHO %RCX_TGTSVR_EXT_IP%> %LOG_PATH%\ipaddr.def

rem FOR /F %%I IN (%LOG_PATH%\ipaddr.def) DO (
rem     "%INST_DIR%\bin\isrcconvbusinessip.exe" "%%I" > %LOG_PATH%\ipaddr2.def
rem )

rem FOR /F %%I IN (%LOG_PATH%\ipaddr2.def) DO (
rem     "%INST_DIR%\bin\isrcdiffnet.exe" %%I %network% %subnet%
rem     IF NOT ERRORLEVEL 1 (
rem         set addr=%%I
rem         "%INST_DIR%\bin\isrcconvlocalhostname.exe" %%I > %LOG_PATH%\localHost.def
rem         FOR %%I IN (%LOG_PATH%\localHost.def) DO (
rem             IF "%%~zI" == "0" (
rem                 ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31364:rc.properties contains invalid data.^(%RCX_SVRGRP_NAME%.localHost^)>>%LOGFILE%
rem                 goto ERROR_RTN
rem             )
rem         )
rem         FOR /F %%I IN (%LOG_PATH%\localHost.def) DO (
rem             set localHost=%%I
rem         )
rem         goto FOR_END
rem     )
rem )
rem ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31394:Acquisition of IP address went wrong>>%LOGFILE%
rem goto ERROR_RTN

:FOR_END
rem     "%INST_DIR%\bin\isrcaddhost.exe" "%WINDIR%\system32\drivers\etc\hosts" %localHost% %addr% > %LOG_PATH%\output.log 2>&1
rem     set status_rc=%ERRORLEVEL%
rem     IF NOT "%status_rc%" == "0" (
rem         IF EXIST "%LOGFILE%" (
rem             COPY "%LOGFILE%" + "%LOG_PATH%\output.log" "%LOGFILE%" /B > NUL 2>&1
rem         ) ELSE (
rem             COPY "%LOG_PATH%\output.log" "%LOGFILE%" > NUL 2>&1
rem         )
rem         DEL /F /Q "%LOG_PATH%\output.log" > NUL 2>&1
rem         ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31393:A setup to hosts cannot be performed ^(code=%status_rc%^)>>%LOGFILE%
rem         goto ERROR_RTN
rem     )
rem     IF "%vtlhost_exist%" == "1" (
rem         "%INST_DIR%\bin\isrcaddhost.exe" "%WINDIR%\system32\drivers\etc\hosts" %virtualHost% %addr% > %LOG_PATH%\output.log 2>&1
rem         set status_rc=%ERRORLEVEL%
rem         IF NOT "%status_rc%" == "0" (
rem             IF EXIST "%LOGFILE%" (
rem                 COPY "%LOGFILE%" + "%LOG_PATH%\output.log" "%LOGFILE%" /B > NUL 2>&1
rem             ) ELSE (
rem                 COPY "%LOG_PATH%\output.log" "%LOGFILE%" > NUL 2>&1
rem             )
rem             DEL /F /Q "%LOG_PATH%\output.log" > NUL 2>&1
rem             ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31393:A setup to hosts cannot be performed ^(code=%status_rc%^)>>%LOGFILE%
rem             goto ERROR_RTN
rem         )
rem     )
rem     DEL /F /Q "%LOG_PATH%\output.log" > NUL 2>&1

rem ECHO network    = %network%>>%INFOFILE%
rem ECHO subnetmask = %subnet%>>%INFOFILE%
rem IF "%vtlhost_exist%" == "1" (
rem ECHO trdVirtualHost = %virtualHost%>>%INFOFILE%
rem )

rem ECHO serverGroupName=%RCX_SVRGRP_NAME%>%STATUSFILE%
rem ECHO businessIpAddress=%addr%>>%STATUSFILE%

DEL /F /Q "%LOG_PATH%\network.def" > NUL 2>&1
DEL /F /Q "%LOG_PATH%\subnet.def" > NUL 2>&1
DEL /F /Q "%LOG_PATH%\localHost.def" > NUL 2>&1
DEL /F /Q "%LOG_PATH%\virtualHost.def" > NUL 2>&1
DEL /F /Q "%LOG_PATH%\ipaddr.def" > NUL 2>&1
DEL /F /Q "%LOG_PATH%\ipaddr2.def" > NUL 2>&1
DEL /F /Q "%LOG_PATH%\output.log" > NUL 2>&1

rem ISCOM START
IF /I %ISCOM_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31808: [ISCOM] is started>>%LOGFILE%

    IF %WEBJ_EDITION%  ==  off  (
        ECHO %INST_DIR%\bin\iscrestoresys.exe -h %localHost% %TARGET_PATH%>>%LOGFILE%
        "%INST_DIR%\bin\iscrestoresys.exe" -h %localHost% "%TARGET_PATH%" >>%LOGFILE% 2>&1
    ) ELSE (
        ECHO %INST_DIR%\bin\iscrestoresys.exe %TARGET_PATH%>>%LOGFILE%
        "%INST_DIR%\bin\iscrestoresys.exe" "%TARGET_PATH%" >>%LOGFILE% 2>&1
    )
    IF ERRORLEVEL 1 (
        FINDSTR /V /R /C:"is318[0-9][0-9]:" %LOGFILE% | FINDSTR /R /C:"is[23][0-9][0-9][0-9][0-9]" | FINDSTR "ERROR: G[:"
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31810: [ISCOM] was failed>>%LOGFILE%
        ECHO IS: ERROR: is31810: [ISCOM] was failed
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31809: [ISCOM] was successful>>%LOGFILE%
    )

)
rem ISCOM END

rem GUI START
IF /I %GUI_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[GUI] is started>>%LOGFILE%

    ECHO %INST_DIR%\gui\bin\isguirestore.bat %INST_DIR% %TARGET_PATH%\isgui>>%LOGFILE%
    call "%INST_DIR%\gui\bin\isguirestore.bat" "%INST_DIR%" "%TARGET_PATH%\isgui" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[GUI] was failed>>%LOGFILE%
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[GUI] was successful>>%LOGFILE%
    )

)
rem GUI END

rem JMX START
IF /I %JMX_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[JMX] is started>>%LOGFILE%

       ECHO %INST_DIR%\bin\isjmxrestore.bat %INST_DIR% %TARGET_PATH%\isjmx %RCX_TGTSVR_ADM_IP% -r>>%LOGFILE%
       call "%INST_DIR%\bin\isjmxrestore.bat" "%INST_DIR%" "%TARGET_PATH%\isjmx" %RCX_TGTSVR_ADM_IP% -r >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[JMX] was failed>>%LOGFILE%
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[JMX] was successful>>%LOGFILE%
    )

)
rem JMX END

rem OD START
IF /I %OD_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31808: [OD] is started>>%LOGFILE%

  IF %WEBJ_EDITION%  ==  off  (
    MOVE %XCOPY_FLAG% %INST_DIR%\td\var\IRDB %INST_DIR%\td\var\IRDB.bak > NUL 2>&1
    ECHO %INST_DIR%\ODWIN\bin\odrestoresys.exe -u %TARGET_PATH%>>%LOGFILE%
    "%INST_DIR%\ODWIN\bin\odrestoresys.exe" -u "%TARGET_PATH%" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        RD /S /Q %INST_DIR%\td\var\IRDB > NUL 2>&1
        MOVE %XCOPY_FLAG% %INST_DIR%\td\var\IRDB.bak %INST_DIR%\td\var\IRDB > NUL 2>&1
        FINDSTR /V /R /C:"is318[0-9][0-9]:" %LOGFILE% | FINDSTR /R /C:"^OD:.*od[0-9][0-9][0-9][0-9][0-9]" | FINDSTR "ERROR: G[:"
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31810: [OD] was failed>>%LOGFILE%
        ECHO IS: ERROR: is31810: [OD] was failed
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31809: [OD] was successful>>%LOGFILE%
    )
rem "%INST_DIR%\ODWIN\bin\odsetconfigex.exe" -d IIOP_hostname >%LOG_PATH%\output.log 2>&1
rem IF ERRORLEVEL 1 (
rem     ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31388:The error occurred to the command ^(odsetconfigex^)>>%LOGFILE%
rem     goto ERROR_RTN
rem )
    DEL /F /Q "%LOG_PATH%\output.log" > NUL 2>&1
    RD /S /Q %INST_DIR%\td\var\IRDB.bak > NUL 2>&1
  ) ELSE (
    ECHO COPY %XCOPY_FLAG% %TARGET_PATH%\ODWIN\config %INST_DIR%\ODWIN\etc\>>%LOGFILE%
    COPY %XCOPY_FLAG% "%TARGET_PATH%\ODWIN\config" "%INST_DIR%\ODWIN\etc\" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31810: [OD] was failed>>%LOGFILE%
        ECHO IS: ERROR: is31810: [OD] was failed
        goto ERROR_RTN
    )

    ECHO COPY %XCOPY_FLAG% %TARGET_PATH%\ODWIN\inithost %INST_DIR%\ODWIN\etc\>>%LOGFILE%
    COPY %XCOPY_FLAG% "%TARGET_PATH%\ODWIN\inithost" "%INST_DIR%\ODWIN\etc\" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31810: [OD] was failed>>%LOGFILE%
        ECHO IS: ERROR: is31810: [OD] was failed
        goto ERROR_RTN
    )

    IF EXIST "%TARGET_PATH%\ODWIN\ssl.env" (
        ECHO COPY %XCOPY_FLAG% %TARGET_PATH%\ODWIN\ssl.env %INST_DIR%\ODWIN\etc\>>%LOGFILE%
        COPY %XCOPY_FLAG% "%TARGET_PATH%\ODWIN\ssl.env" "%INST_DIR%\ODWIN\etc\" >>%LOGFILE% 2>&1
        IF ERRORLEVEL 1 (
            ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31810: [OD] was failed>>%LOGFILE%
            ECHO IS: ERROR: is31810: [OD] was failed
            goto ERROR_RTN
        )
    )
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31809: [OD] was successful>>%LOGFILE%
  )

)
rem OD END

rem ES START
IF /I %ES_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[ES] is started>>%LOGFILE%

    ECHO %INST_DIR%\bin\esrestoresys.exe -d %TARGET_PATH%>>%LOGFILE%
    "%INST_DIR%\bin\esrestoresys.exe" -d "%TARGET_PATH%" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 0 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[ES] was successful>>%LOGFILE%
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[ES] was failed>>%LOGFILE%
        goto ERROR_RTN
    )

)
rem ES END

rem TD START
IF /I %TD_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[TD] is started>>%LOGFILE%

    ECHO %INST_DIR%\bin\tdrestoresys.exe %TARGET_PATH%>>%LOGFILE%
    "%INST_DIR%\bin\tdrestoresys.exe" "%TARGET_PATH%" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[TD] was failed>>%LOGFILE%
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[TD] was successful>>%LOGFILE%
    )

)
rem TD END

rem OTS START
IF /I %OTS_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[OTS] is started>>%LOGFILE%

    ECHO %INST_DIR%\bin\otsrestoresys.exe %TARGET_PATH%>>%LOGFILE%
    "%INST_DIR%\bin\otsrestoresys.exe" "%TARGET_PATH%" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[OTS] was failed>>%LOGFILE%
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[OTS] was successful>>%LOGFILE%
    )

)
rem OTS END

rem JMS START
IF /I %JMS_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[JMS] is started>>%LOGFILE%

    ECHO %INST_DIR%\bin\jmsrestore.exe -d %TARGET_PATH%>>%LOGFILE%
    "%INST_DIR%\bin\jmsrestore.exe" -d "%TARGET_PATH%" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[JMS] was failed>>%LOGFILE%
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[JMS] was successful>>%LOGFILE%
    )

)
rem JMS END

rem J2EE START
IF /I %J2EE_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[J2EE] is started>>%LOGFILE%

    ECHO %INST_DIR%\bin\j2eerestore.exe -d %TARGET_PATH%>>%LOGFILE%
    "%INST_DIR%\bin\j2eerestore.exe" -d "%TARGET_PATH%" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[J2EE] was failed>>%LOGFILE%
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[J2EE] was successful>>%LOGFILE%
    )

)
rem J2EE END

rem IJServer START
IF /I %IJSERVER_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[IJServer] is started>>%LOGFILE%

    ECHO %INST_DIR%\bin\ijsrestore.exe -d %TARGET_PATH%>>%LOGFILE%
    "%INST_DIR%\bin\ijsrestore.exe" -d "%TARGET_PATH%" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[IJServer] was failed>>%LOGFILE%
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[IJServer] was successful>>%LOGFILE%
    )

)
rem IJServer END

rem ISCM START
IF /I %ISCM_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31390:[ISCM] is started>>%LOGFILE%

    ECHO %INST_DIR%\bin\isreprestore %TARGET_PATH%\jmx_cm>>%LOGFILE%
    call "%INST_DIR%\bin\isreprestore" "%TARGET_PATH%\jmx_cm" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31392:[ISCM] was failed>>%LOGFILE%
        goto ERROR_RTN
    ) ELSE (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31391:[ISCM] was successful>>%LOGFILE%
    )

)
rem ISCM END

rem ISJEE START
IF /I %ISJEE_TARGET%  ==  on  (
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31808: [ISJEE] is started>>%LOGFILE%

    ECHO %INST_DIR%\F3FMisjee\bin\ijrestore.bat -d %TARGET_PATH% -h %localHost%>>%LOGFILE%
    call "%INST_DIR%\F3FMisjee\bin\ijrestore.bat" -d "%TARGET_PATH%" -h "%localHost%" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        FINDSTR /V /R /C:"is318[0-9][0-9]:" %LOGFILE% | FINDSTR /R /C:"ISJEE_OM40[0-9][0-9]" | FINDSTR /V /R /C:"ISJEE_OM400[25]" | FINDSTR "ERROR: G[:"
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31810: [ISJEE] was failed>>%LOGFILE%
        ECHO IS: ERROR: is31810: [ISJEE] was failed
        goto ERROR_RTN
    )
    ECHO keytool -delete -alias s1as -keystore "%KEYSTORE_PATH%\keystore.jks" -storepass changeit>>%LOGFILE%
    keytool -delete -alias s1as -keystore "%KEYSTORE_PATH%\keystore.jks" -storepass changeit>>%LOGFILE% 2>&1
    ECHO keytool -genkey -keyalg RSA -keystore "%KEYSTORE_PATH%\keystore.jks" -storepass changeit -alias s1as -keypass changeit -dname CN=%localHost% -validity 10950>>%LOGFILE%
    keytool -genkey -keyalg RSA -keystore "%KEYSTORE_PATH%\keystore.jks" -storepass changeit -alias s1as -keypass changeit -dname CN=%localHost% -validity 10950>>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31811: A system error occurred^(The command ^(keytool -genkey^) was failed^)>>%LOGFILE%
        ECHO IS: ERROR: is31811: A system error occurred^(The command ^(keytool -genkey^) was failed^)
        goto ERROR_RTN
    )

    ECHO %INST_DIR%\F3FMisjee\bin\ijdasstart>>%LOGFILE%
    "%INST_DIR%\F3FMisjee\bin\ijdasstart" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31811: A system error occurred^(The command ^(ijdasstart^) was failed^)>>%LOGFILE%
        ECHO IS: ERROR: is31811: A system error occurred^(The command ^(ijdasstart^) was failed^)
        goto ERROR_RTN
    )
    ECHO %INST_DIR%\F3FMisjee\bin\ijnastart>>%LOGFILE%
    "%INST_DIR%\F3FMisjee\bin\ijnastart" >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31811: A system error occurred^(The command ^(ijnastart^) was failed^)>>%LOGFILE%
        ECHO IS: ERROR: is31811: A system error occurred^(The command ^(ijnastart^) was failed^)
        goto ERROR_RTN
    )

    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31809: [ISJEE] was successful>>%LOGFILE%
)
rem ISJEE END

IF /I %OD_TARGET%  ==  on  (
    "%OD_HOME%\bin\OD_set_env.exe" -n %localHost% >%LOG_PATH%\output.log 2>&1
    IF ERRORLEVEL 1 (
        IF EXIST "%LOGFILE%" (
            COPY "%LOGFILE%" + "%LOG_PATH%\output.log" "%LOGFILE%" /B > NUL 2>&1
        ) ELSE (
            COPY "%LOG_PATH%\output.log" "%LOGFILE%" > NUL 2>&1
        )
        DEL /F /Q "%LOG_PATH%\output.log" > NUL 2>&1
        FINDSTR /V /R /C:"is318[0-9][0-9]:" %LOGFILE% | FINDSTR /R /C:"^OD:.*od[0-9][0-9][0-9][0-9][0-9]" | FINDSTR "ERROR: G[:"
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31811: A system error occurred^(The command^(OD_set_env^) was failed^)>>%LOGFILE%
        ECHO IS: ERROR: is31811: A system error occurred^(The command^(OD_set_env^) was failed^)>>%LOGFILE%
        goto ERROR_RTN
    )
)

rem     IF EXIST "%INST_DIR%\bin\isleavesite.exe" (
rem         "%INST_DIR%\bin\isleavesite.exe" -f >%LOG_PATH%\output.log 2>&1
rem         IF ERRORLEVEL 1 (
rem             IF EXIST "%LOGFILE%" (
rem                 COPY "%LOGFILE%" + "%LOG_PATH%\output.log" "%LOGFILE%" /B > NUL 2>&1
rem             ) ELSE (
rem                 COPY "%LOG_PATH%\output.log" "%LOGFILE%" > NUL 2>&1
rem             )
rem             DEL /F /Q "%LOG_PATH%\output.log" > NUL 2>&1
rem             ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31388:The error occurred to the command ^(isleavesite^)>>%LOGFILE%
rem             goto ERROR_RTN
rem         )
rem     )

    DEL /F /Q "%LOG_PATH%\output.log" > NUL 2>&1

DEL /F /Q %SVCTRACEFILE% > NUL 2>&1

rem NET START "Interstage Operation Tool" > NUL 2>&1

rem Interstage Start
rem "%INST_DIR%\bin\isstart" >>%LOGFILE% 2>&1
rem IF ERRORLEVEL 1 (
rem     ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31811: A system error occurred^(The command ^(isstart^) was failed^)>>%LOGFILE%
rem     ECHO IS: ERROR: is31811: A system error occurred^(The command ^(isstart^) was failed^)
rem     goto ERROR_RTN
rem )
    cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" RestoreStartup -C:INTS_APSR >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs RestoreStartup^) was failed^)>>%LOGFILE%
        ECHO IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs RestoreStartup^) was failed^)
        goto ERROR_RTN
    )
    cscript //NoLogo "%~dp0\isswcmPrepService.vbs" StartServicesWithOSConf -C:INTS_APSR >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31811: A system error occurred^(The command ^(isswcmPrepService.vbs StartServicesWithOSConf^) was failed^)>>%LOGFILE%
        ECHO IS: ERROR: is31811: A system error occurred^(The command ^(isswcmPrepService.vbs StartServicesWithOSConf^) was failed^)
        goto ERROR_RTN
    )

    IF EXIST "%COMMON_PATH%\services2.tmp.swcm" (
        cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" Unregister -G:INTS_APSR2 >>%LOGFILE% 2>&1
        IF ERRORLEVEL 1 (
            ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs Unregister^) was failed^)>>%LOGFILE%
            ECHO IS: ERROR: is31811: A system error occurred^(The command ^(isrcPrepService.vbs Unregister^) was failed^)
            goto ERROR_RTN
        )
        DEL /F /Q "%COMMON_PATH%\services2.tmp.swcm" > NUL 2>&1
    )

rem ==========================================================================
rem Exit
rem ==========================================================================
:EXIT_RTN
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31806: %THIS_CMD_NAME% has been finished normally>>%LOGFILE%
    set RET_VAL=0
    EXIT /B %RET_VAL%
    ENDLOCAL

rem ==========================================================================
rem Error
rem ==========================================================================
:ERROR_RTN
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31807: An error occurred while processing %THIS_CMD_NAME%>>%LOGFILE%
    set RET_VAL=1
    EXIT /B %RET_VAL%
    ENDLOCAL

rem ==========================================================================
:PRE_PART
rem ==========================================================================
IF NOT EXIST %COMMON_PATH% (
    MD "%COMMON_PATH%"
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31354:Making the directory was failed^(path=%COMMON_PATH%^)>%INST_DIR%\var\isrcimportimg.log
        goto ERROR_PRE
    )
)
IF NOT EXIST %LOG_PATH% (
    MD "%LOG_PATH%"
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31354:Making the directory was failed^(path=%LOG_PATH%^)>%INST_DIR%\var\isrcimportimg.log
        goto ERROR_PRE
    )
)

ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31385:isrcimportimg(%1) is started>%LOGFILE%

    "%INST_DIR%\bin\isrccrtservicelist" 2>&1
    IF ERRORLEVEL 9 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31388:The error occurred to the command ^(isrccrtservicelist^)>>%LOGFILE%
        goto ERROR_PRE
    )
    IF ERRORLEVEL 3 (
        cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" Unregister -G:INTS_APSR2 >>%LOGFILE% 2>&1
        IF ERRORLEVEL 1 (
            ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31388:The error occurred to the command ^(isrcPrepService.vbs Unregister^)>>%LOGFILE%
            goto ERROR_PRE
        )
        cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" Register -F:"%INST_DIR%\var\rc\services2.tmp" -G:INTS_APSR2 -C:INTS_APSR >>%LOGFILE% 2>&1
        IF ERRORLEVEL 1 (
            ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31388:The error occurred to the command ^(isrcPrepService.vbs Register^)>>%LOGFILE%
            goto ERROR_PRE
        )
        goto NEXT
    )
    IF ERRORLEVEL 2 (
        cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" Register -F:"%INST_DIR%\var\rc\services2.tmp" -G:INTS_APSR2 -C:INTS_APSR >>%LOGFILE% 2>&1
        IF ERRORLEVEL 1 (
            ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31388:The error occurred to the command ^(isrcPrepService.vbs Register^)>>%LOGFILE%
            goto ERROR_PRE
        )
        goto NEXT
    )
    IF ERRORLEVEL 1 (
        cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" Unregister -G:INTS_APSR2 >>%LOGFILE% 2>&1
        IF ERRORLEVEL 1 (
            ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31388:The error occurred to the command ^(isrcPrepService.vbs Unregister^)>>%LOGFILE%
            goto ERROR_PRE
        )
        goto NEXT
    )
:NEXT

rem Interstage Stop
    cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" SuppressStartup -C:INTS_APSR >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31388:The error occurred to the command ^(isrcPrepService.vbs SuppressStartup^)>>%LOGFILE%
        goto ERROR_PRE
    )
    "%INST_DIR%\bin\isstop" -f 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31388:The error occurred to the command ^(isstop -f^)>>%LOGFILE%
        goto ERROR_PRE
    )
    cscript //NoLogo "%INST_DIR%\bin\isrcPrepService.vbs" StopServices -C:INTS_APSR >>%LOGFILE% 2>&1
    IF ERRORLEVEL 1 (
        ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31388:The error occurred to the command ^(isrcPrepService.vbs StopServices^)>>%LOGFILE%
        goto ERROR_PRE
    )

:EXIT_PRE
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: INFO: is31386:isrcimportimg(%1) was ended normally>>%LOGFILE%
    set RET_VAL=0
    EXIT %RET_VAL%
    ENDLOCAL

:ERROR_PRE
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31387:isrcimportimg(%1) was ended failure>>%LOGFILE%
    set RET_VAL=1
    EXIT %RET_VAL%
    ENDLOCAL

:ERROR_QUIT
    IF NOT EXIST %COMMON_PATH% (
        MD "%COMMON_PATH%"
    )
    IF NOT EXIST %LOG_PATH% (
        MD "%LOG_PATH%"
    )
    ECHO [%DATE:~-10% %TIME:~0,8%] IS: ERROR: is31395:Invalid parameter>>%LOGFILE%
    ECHO IS: ERROR: is31395:Invalid parameter
    set RET_VAL=1
    EXIT %RET_VAL%
    ENDLOCAL
